*===== 6́FSAS}N ;

*--- 6.1 ;
*--- Example 1 ;
options mprint ;
data DT ;
   input X Y ;
cards;
10 20
12 40
15 32
;
run ;

*--- SAS}N̒` ;
%macro PRINT_DS ;
   proc print data=DT ;
   run ;
%mend PRINT_DS ;

*--- SAS}N̒s ;
%PRINT_DS ;

*--- 6.2 ;
*--- }Nϐ ;
options mprint symbolgen ;
%macro PRINT_DS2(DSN) ;
   proc print data=&DSN. ;
   run ;
%mend PRINT_DS2 ;

%PRINT_DS2(DT) ;

*--- ̃}Nϐ ;
options mprint symbolgen ;
data DT1 ;
   input TREAT $ N ;
cards;
A 15
B 15
;
run ;

data DT2 ;
   input GENDER $ N ;
cards;
j 10
 20
;
run ;

%macro PRINT_DS3(DSN1,DSN2) ;
   proc print data=&DSN1. ; run ;
   proc print data=&DSN2. ; run ;
%mend PRINT_DS3 ;

%PRINT_DS3(DT1,DT2) ;

%PRINT_DS3(DSN1=DT1,DSN2=DT2) ;

*--- l̎w ;
%macro PRINT_DS3(DSN1=DT1,DSN2=DT2) ;
   proc print data=&DSN1. ; run ;
   proc print data=&DSN2. ; run ;
%mend PRINT_DS3 ;

%PRINT_DS3 ;

*--- %let,%put ;
*--- 1 ;
%let VARIABLE = WEIGHT ;
%put }NϐVARIABLEɊi[Ăl &VARIABLE łB ;

*--- 2 ;
%let VARIABLE = WEIGHT ;
data &VARIABLE ;
   ID  = 1 ;
   WGT = 70 ;
run ;

*--- 3 ;
%let X1 = 2 ;
%let X2 = 3 ;
%let X3 = %eval(&X1 + &X2) ;
%put *** &X1 + &X2 = &X3 *** ;

*-- call symput ;
data _null_ ;
   call symput('MV1','SYMPUT') ; *--- ̂܂܊i[ ;
   X1 = 'SYMPUT2' ;
   call symput('MV2',X1) ; *--- X1̒li[ ;
   X2 = 10 ;
   call symput('MV3',compress(put(X2,best.))) ; *--- X2𕶎ɕϊĊi[ ;
   X3 = '4' ;
   call symput('MV'||X3,'TEST') ; *--- }NϐMV4ɕi[ ;
run ;

*--- }Nϐ̒lmF ;
%put MV1: &MV1 MV2: &MV2 MV3: &MV3 MV4: &MV4 ;

*--- symget֐ ;
*--- gp1 ;
%let A = TEST ;
data _SYMGET ;
   VALUE = symget('A') ;
run ;
proc print data=_SYMGET ; run ;

*--- gp2 ;
%let A1 = VAL1 ;
%let A2 = VAL2 ;

data VAL ;
   input X $ ;
cards;
A1
A2
;
run ;

data _SYMGET2 ;
   set VAL ;
   VALUE = symget(X) ;
run ;

proc print data=_SYMGET2 ; run ;

*--- }Nϐ ;
data _SYS ;
   x=1 ;
run ;

%put SYSDATE:  &SYSDATE ;
%put SYSDATE9: &SYSDATE9 ;
%put SYSDSN:   &SYSDSN ;
%put SYSERR:   &SYSERR ;
%put SYSLAST:  &SYSLAST ;
%put SYSSCPL:  &SYSSCPL ;
%put SYSVER:   &SYSVER ;

*--- globallocal ;
%global X ;

%macro LG ;
   %let X = GLOBAL ;

   %local Y ;
   %let Y = LOCAL ;
   %put Y: &Y ;
%mend LG ;
%LG ;
%put X: &X ;

*--- sqlvVWintoXe[gg ;
*--- 1 ;
data INTO1 ;
   X = "INTO" ;
run ;

proc sql noprint ;
   select X into: _X1 from INTO1 ;
quit ;

%put _X: &_X1 ;

*--- 2 ;
data INTO2 ;
   input X $ @@ ;
cards;
a b c
;
run ;

proc sql noprint ;
   select X into: _X2 separated by ',' from INTO2 ;
quit ;

%put _X2: &_X2 ;

*--- 3 ;
data INTO3 ;
   input Y Z $ ;
cards;
1 a
2 b
3 c
;
run ;

proc sql noprint ;
   select Y,Z into: _Y separated by "," , : _Z separated by "|"
      from INTO3 ;
quit ;

%put &_Y ;
%put &_Z ;

*--- 4 ;
proc sql noprint ;
   select catx('=',compress(put(Y,best.)),quote(compress(Z))) into: FMT separated by " "
      from INTO3 ;
quit ;

%put FMT: &FMT ;

proc format ;
   value ABCFMT &FMT ;
run ;

*--- 6.3 %ifXe[gg ;
*--- 1 ;
options mprint symbolgen mlogic ;
%macro PRINT_IF(FLAG=) ;
   proc print data=%if       &FLAG=1 %then DT1 ;
                   %else %if &FLAG=2 %then DT2 ;;
   run ;
%mend PRINT_IF ;

%PRINT_IF(FLAG=1) ;
%PRINT_IF(FLAG=2) ;

*--- 2 ;
options mprint symbolgen mlogic ;
data BP ;
   input ID DBP SBP ;
cards;
1  80 123
2  90 142
3  83 115
4  77 106
5  95 150
6  85 132
7  65 105
8  72 127
9  88 140
10 98 155
;
run ;

%macro MEANS_PRINT(FLAG=) ;
   %if &FLAG = 1 %then %do ;
      proc means data=BP ; var DBP SBP ; run ;
   %end ;
   %if &FLAG = 2 %then %do ;
      proc print data=BP ; run ;
   %end ;
%mend MEANS_PRINT ;

%MEANS_PRINT(FLAG=1) ;
%MEANS_PRINT(FLAG=2) ;

*--- 6.4 %doXe[gg ;
*--- %do - %end ;
data DO1 ;
   input AREA $ AIRTEMP @@ ;
cards;
s 21 { 23 ꌧ 28
;
run ;
data DO2 ;
   input AREA $ HUMIDITY @@ ;
cards;
s 41 { 58 ꌧ 84
;
run ;
data DO3 ;
   input AREA $ POP @@ ;
cards;
s 20 { 50 ꌧ 90
;
run ;

%macro DO_PRINT ;
   %do I =1 %to 3 %by 1 ;
      proc print data=DO&I ; run ;
   %end ;
%mend DO_PRINT ;

%DO_PRINT ;

*--- %do %while - %end ;
%macro DO_WHILE ;
   %let I = 1 ;
   %do %while(&I <= 3) ;
      proc print data=DO&I ; run ;
      %let I = %eval(&I + 1) ;
   %end ;
%mend DO_WHILE ;

%DO_WHILE ;

*--- %do %until - %end ;
%macro DO_UNTIL ;
   %let I = 1 ;
   %do %until(&I > 3) ;
      proc print data=DO&I ; run ;
      %let I = %eval(&I + 1) ;
   %end ;
%mend DO_UNTIL ;

%DO_UNTIL ;

*--- 6.5 p ;
%let A = Variable ;
data QUOTE ;
   X1='Pp: &A' ;
   X2="dp: &A" ;
run ;

title1 'Pp: &A' ;
title2 "dp: &A" ;
proc print data=QUOTE ; run ;
title ;

*--- 6.6 }N֐ ;
*--- vZ ;
%let A = 4.3 ;
%let B = 3 ;
%let C = %sysevalf(&A*&B) ;
%put *** &A * &B = &C *** ;

*--- }XLO ;
*--- %str,%nrstr ;
%let PRINT = %str(proc print data=STR ; run ;) ;
%let LABEL = %nrstr(A&B) ;
%put *** &PRINT *** ;
%put *** &LABEL *** ;

%let PRINT = proc print data=STR ; run ; ;
%let LABEL = A&B ;
%put *** &PRINT *** ;
%put *** &LABEL *** ;

*--- %quote,%bquote ;
%let A = apple ;
%let B = car ;

%let X1 = %quote(This is an &A..) ;
%let X2 = %bquote(It's a &B..) ;

%put &X1 ;
%put &X2 ;

*--- %sysfunc ;
*--- ֐ ;
%let CHAR1 = %sysfunc(catx(=,A,B)) ;
%let CHAR2 = %sysfunc(compress(&))AAA ;
%let CHAR3 = %qsysfunc(compress(&))AAA ;

%put *** &CHAR1 *** ;
%put *** &CHAR2 *** ;
%put *** &CHAR3 *** ;

*--- l֐ ;
%let NUM1 = %sysfunc(int(1.2)) ;
%let NUM2 = %sysevalf(%sysfunc(mean(1,5,7))+%sysfunc(std(1,5,7))) ;
%let NUM3 = %sysfunc(round(&NUM2,.01)) ;

%put *** &NUM1 *** ;
%put *** &NUM2 *** ;
%put *** &NUM3 *** ;

*--- 6.7 ̃ApTh ;
data DT1 ;
   input WGT @@ ;
cards;
80 85 74 67 72 58 66 63 51 45
;
run ;

data DT2 ;
   input ABD @@ ;
cards;
88 95 87 78 81 77 90 102 99 70
;
run ;

data DT3 ;
   input LDL @@ ;
cards;
150 127 110 141 102 99 135 120 85 89
;
run ;

%macro NMEANS(DATA1=,DATA2=,DATA3=,VAR1=,VAR2=,VAR3=) ;
   %do I = 1 %to 3 ;
      proc means data=&&DATA&I n mean stddev min median max maxdec=2 ;
         var &&VAR&I ;
      run ;
   %end ;
%mend NMEANS ;

%NMEANS(DATA1=DT1,DATA2=DT2,DATA3=DT3,VAR1=WGT,VAR2=ABD,VAR3=LDL) ;

*--- 6.8 v̓}N ;
*--- ttest ;
proc format ;
   value TRTF 1 = "A" 2 = "B" ;
run ;

data WGTDT ;
   do TREAT = 1 to 2 ;
      do I = 1 to 10 ;
         input WGT @@ ;
         output ;
      end ;
   end ;
   format TREAT TRTF. ;
cards;
80 85 74 67 72 58 66 63 51 45
75 90 70 63 88 89 56 90 83 63
;
run ;

%macro TWOSAMP_T(DATA=,VAR=,GRP=) ;
   proc ttest data=&DATA ;
      class &GRP ;
      var &VAR ;
   run ;
%mend TWOSAMP_T ;

%TWOSAMP_T(DATA=WGTDT,VAR=WGT,GRP=TREAT) ;

*--- 2x2\ ;
proc format ;
   value HEALF 1 = "" 2 = "" ;
run ;

data TESTDT ;
   input TREAT HEAL NN ;
   format TREAT TRTF. HEAL HEALF. ;
cards;
1 1 35
1 2 20
2 1 28
2 2 26
;
run ;

%macro FREQ_BIN(DATA=,GRP=,VAL=,W=,RD=,RR_OR=,CHI=) ;
   proc freq data=&DATA ;
      %if &W ne %str() %then weight &W ;;
      table &GRP*&VAL / %if &RD    = yes %then riskdiff ;
                        %if &RR_OR = yes %then relrisk  ;
                        %if &CHI   = yes %then chisq    ;;
   run ;
%mend FREQ_BIN ;

%FREQ_BIN(DATA=TESTDT,GRP=TREAT,VAL=HEAL,W=NN,RD=yes,RR_OR=yes,CHI=yes) ;

*--- XN̂ ;
%FREQ_BIN(DATA=TESTDT,GRP=TREAT,VAL=HEAL,W=NN,RD=yes,RR_OR=no,CHI=no) ;

*--- A ;
data WGTHGT ;
   do I = 1 to 10 ;
      input WGT HGT @@ ;
      output ;
   end ;
cards;
80 175 85 178 74 169 67 168 72 173 58 160 66 170 63 161 51 157 45 155
;
run ;

%macro REG_M(DATA=,Y=,X=,INT=yes) ;
   proc reg data=&DATA ;
      model &Y = &X %if &INT ne yes %then / noint ;;
   run ; quit ;
%mend REG_M ;

%REG_M(DATA=WGTHGT,Y=WGT,X=HGT) ;

*--- notint ;
%REG_M(DATA=WGTHGT,Y=WGT,X=HGT,INT=no) ;

*--- U ;
proc format ;
   value TRT2F 1 = "A" 2 = "B" 3 = "C" ;
run ;

data BP ;
   do TREAT = 1 to 3 ;
      do I = 1 to 10 ;
          input SBP_CHG @@ ;
          output ;
      end ;
   end ;
   format TREAT TRT2F. ;
cards;
 -5  -6  -8  -6   0   4  -2   6  -2   3
-15 -20 -15 -12 -21 -13 -14   3 -11  -9
 -7   9  11 -18   3 -12  -3  -9  -8   1
;
run ;

%macro GLM_M(DATA=,GRP=,Y=,X=,MEANS=,CONT=) ;
   %if &MEANS = yes %then %do ;
      proc means data=&DATA ;
         class &GRP ;
         var &Y ;
      run ;
   %end ;

   proc glm data=&DATA ;
      class &GRP &X ;
      model &Y = &GRP &X / ss3 ;
      %if &CONT ne %str() %then contrast "Contrast" &GRP &CONT / e ;;
   run ; quit ;
%mend GLM_M ;

%GLM_M(DATA=BP,GRP=TREAT,Y=SBP_CHG,X=,MEANS=yes,CONT=%str(-1 1 0)) ;

*--- ԉ ;
proc format ;
   value TRTF 1 = "1" 2 = "2" ;
run ;

data LIFE_EV ;
   do TREAT = 1 to 2 ;
      input DAYS CEN @@ ;
      output ;
   end ;
   format TREAT TRTF. ;
cards;
85 1 112 1  38 1 55 0 148 1 188 1 140 0 123 1
88 1 96  0 112 1 87 1  76 1 156 1  78 0 198 1
;
run ;

%macro LIFETEST_M(DATA=,TIME=,CENSOR=,CENVAL=,STRATA=) ;
   proc lifetest data=&DATA ;
      time &TIME*&CENSOR(&CENVAL) ;
      strata &STRATA ;
   run ;
%mend LIFETEST_M ;

%LIFETEST_M(DATA=LIFE_EV,TIME=DAYS,CENSOR=CEN,CENVAL=0,STRATA=TREAT) ;

*--- Cox ;
%macro CON_M(DATA=,CLASS=,TIME=,CENSOR=,CENVAL=,X=,TIES=) ;
   proc phreg data=&DATA ;
      class &CLASS ;
      model &TIME*&CENSOR(&CENVAL) = &X / ties=&TIES ;
   run ;
%mend CON_M ;

%CON_M(DATA=LIFE_EV,CLASS=TREAT,TIME=DAYS,CENSOR=CEN,CENVAL=0,X=TREAT,TIES=exact) ;

*--- ᐔ݌v: 2t ;
%macro POWER_DIFF(ALPHA=,SIDES=,DIFF=,NULLDIFF=0,SD=, POWER=,NTOTAL=) ;
   proc power ;
      twosamplemeans
      test     = diff
      alpha    = &AlPHA
      sides    = &SIDES
      meandiff = &DIFF
      nulldiff = &NULLDIFF
      stddev   = &SD
      power    = &POWER
      ntotal   = &NTOTAL ;
   run ;
%mend POWER_DIFF ;

%POWER_DIFF(ALPHA=0.025,SIDES=1,DIFF=2,SD=4,POWER=0.8,NTOTAL=.) ;

%POWER_DIFF(ALPHA=0.025,SIDES=1,DIFF=1 to 5 by 1,SD=3 to 5 by 1,POWER=0.8,NTOTAL=.) ;

*--- ᐔ݌v: proportion diff ;
%macro POWER_BIN(ALPHA=,SIDES=,GROUPPS=,NULLPDIFF=0,POWER=,NTOTAL=) ;
   proc power ;
      twosamplefreq
      test      = pchi
      alpha     = &ALPHA
      sides     = &SIDES
      groupps   = &GROUPPS
      nullpdiff = &NULLPDIFF
      power     = &POWER
      ntotal    = &NTOTAL  ;
run ;
%mend POWER_BIN ;

%POWER_BIN(ALPHA=0.05,SIDES=2,GROUPPS=(0.8 0.7), POWER=0.8,NTOTAL=.) ;

%POWER_BIN(ALPHA=0.05,SIDES=2,GROUPPS=0.8 0.85 0.9 | 0.7, POWER=0.8,NTOTAL=.) ;

*--- ᐔ݌v: Survival Analysis ;
%macro POWER_SURV(ALPHA=,SIDES=,LABEL1=,LABEL2=,TIME1=,TIME2=,RATE1=,RATE2=,
                  ATIME=0.001,FTIME=,POWER=,NTOTAL=) ;
   proc power ;
      twosamplesurvival
      test           = logrank
      alpha          = &ALPHA
      sides          = &SIDES
      %do I = 1 %to 2 ;
         curve("&&LABEL&I") = (&&TIME&I):(&&RATE&I)
      %end ;
      groupsurvival  = "&LABEL1" | "&LABEL2"
      accrualtime    = &ATIME
      followuptime   = &FTIME 
      power          = &POWER
      ntotal         = &NTOTAL ; 
   run ;
%mend POWER_SURV ;

%POWER_SURV(ALPHA=0.05,SIDES=2,LABEL1=%str(A),LABEL2=%str(B),
            TIME1=2,TIME2=2,RATE1=0.9,RATE2=0.8,FTIME=5,POWER=0.8,NTOTAL=.) ;

*--- 6.9 |[g쐬}N ;

*--- f[^̍쐬 ;
data HAIKEI ;
   input ID TREAT AGE GENDER SMOKE WEIGHT FPG ;
cards;
1  1 79 2 1 78.6  142
2  2 53 1 2 63.1  140
3  2 58 1 2 56.5  106
4  1 51 2 2 101.0 119
5  1 68 2 2 98.2  134
6  2 53 1 1 53.1  106
7  1 53 2 2 80.3  118
8  1 50 2 1 62.2  114
9  1 64 1 2 68.3  84
10 2 67 2 2 58.1  123
11 1 57 1 1 76.8  127
12 2 41 2 2 76.6  116
13 1 52 2 1 77.4  130
14 2 50 2 2 77.9  118
15 1 41 2 2 88.4  109
16 1 51 1 2 61.2  103
17 2 38 2 1 79.5  134
18 2 55 1 1 49.2  106
19 1 57 2 2 50.2  110
20 1 43 2 2 76.9  107
21 2 62 1 2 60.3  113
22 1 43 1 2 62.0  120
23 1 57 1 1 84.9  116
24 2 50 2 1 81.9  121
25 1 47 1 1 79.3  103
26 1 45 1 1 74.7  105
27 1 60 2 2 58.9  114
28 1 58 1 1 44.7  114
29 2 61 1 1 60.5  136
30 1 68 2 1 100.6 126
31 2 50 2 2 97.2  116
32 2 50 2 2 80.7  144
33 1 68 1 2 38.7  124
34 2 53 1 2 67.3  123
35 2 48 1 2 62.0  139
36 1 52 1 1 56.1  126
37 2 57 1 2 60.6  117
38 2 56 1 2 73.0  114
39 2 55 1 1 77.5  121
40 2 47 1 1 70.2  122
41 2 51 1 1 64.0  119
42 2 53 1 1 57.9  125
43 2 62 1 1 67.8  136
44 1 49 2 2 65.7  108
45 2 41 1 2 77.0  123
46 2 60 1 2 55.9  111
47 2 52 2 1 94.5  124
48 1 63 2 1 74.1  117
49 2 61 2 1 80.1  105
50 1 57 1 1 69.8  130
51 1 60 1 2 64.6  104
52 1 60 1 2 62.8  110
53 2 65 2 2 72.0  110
54 2 46 1 2 82.9  111
55 2 50 2 2 88.2  129
56 1 59 1 2 58.9  144
57 1 51 1 2 59.5  120
58 2 57 1 2 52.8  124
59 2 58 2 1 84.7  109
60 2 71 2 2 60.6  103
;
run ;


*--- v񓝌vʂ̃|[g ;
%macro SUM_STAT(DATA=,GRP=,VAR=,VARLABEL=,STAT=,STATF=) ;
   *--- 1. vʂ̃JEg,L[[hƃtH[}bg̒o ;
   %let I = 1 ;
   %do %while(%scan(&STAT,&I) ne %str()) ;
      %let STAT_N = &I ;
      %let STAT&I  = %scan(&STAT ,&I) ;
      %let STATF&I = %scan(&STATF,&I,%str( )) ;
      %let I = %eval(&I + 1) ;
   %end ;
   *--- 2. v񓝌vʂ̎Zo ;
   proc summary data=&DATA nway ;
       class &GRP ;
       var &VAR ;
       output out=_OUT(drop=_FREQ_ _TYPE_)
       %do J = 1 %to &STAT_N ;
          &&STAT&J = &&STAT&J
       %end ;;
   run ;
   *--- 3. f[^Zbg̓]u: v񓝌vʂc,eQɓWJ ;
   proc transpose data=_OUT out=_OUT_T prefix=GRP ;
      var %do J = 1 %to &STAT_N ; &&STAT&J %end ;;
      id &GRP ;
   run ;      
   *--- 4. tH[}bg̊蓖Ăƕϐւ̕ϊ ;
   data RES_CONT ;
      length LABEL _NAME_ _RES1 _RES2 $20. ;
      set _OUT_T ;
      LABEL = "&VARLABEL" ;
      %do K = 1 %to &STAT_N ;
         if _NAME_ = "&&STAT&K" then do ;
            _RES1 = put(GRP1,&&STATF&K) ;
            _RES2 = put(GRP2,&&STATF&K) ;
         end ;
      %end ;
      keep LABEL _NAME_ _RES1 _RES2 ;
   run ;
   *--- 5. |[g쐬 ;
   proc report data=RES_CONT nowd ;
      column LABEL _NAME_ _RES1 _RES2 ;
      define LABEL  / order "" ;
      define _NAME_ / display "v񓝌v" ;
      define _RES1  / display "1" style={just=r} ;
      define _RES2  / display "2" style={just=r} ;
   run ;
%mend SUM_STAT ;

%SUM_STAT(DATA=HAIKEI,GRP=TREAT,VAR=WEIGHT,VARLABEL=%str(Weight(kg)),
           STAT=n mean stddev min median max,
           STATF=8. 8.2 8.3 8.1 8.2 8.1) ;

*--- JeSϐ̃|[g ;
%macro SUM_CAT(DATA=,GRP=,VAR=,VARLABEL=,VARF=) ;
   *--- 1. ᐔƃp[ZgZo ;
   ods listing close ;
   proc tabulate data=&DATA out=_OUT ;
      class &GRP &VAR ;
      table &GRP,&VAR*(n rowpctn)  ;
   run ;
   ods listing ;
   *--- 2. N(%)Ƃ邽߂ɕϐɕϊ ;
   data _OUT2 ;
      set _OUT ;
      _RES=put(N,best.)||"("||put(pctn_10,6.1)||")" ;
   run ;
   proc sort data=_OUT2 ; by &VAR ; run ;
   *--- 3. f[^Zbg̓]u: N(%)c,eQɓWJ ;
   proc transpose data=_OUT2 out=_OUT_T prefix=_RES ;
      by &VAR ;
      var _RES ;
      id &GRP ;
   run ;
   *--- 4. eJeSւ̃tH[}bg̊蓖 ;
   data RES_CAT ;
      length LABEL _NAME_ $20. ;
      LABEL="&VARLABEL" ;
      set _OUT_T ;
      _NAME_ = left(put(&VAR,&VARF..)) ;
      keep LABEL _NAME_ _RES1 _RES2 ; 
   run ;
   *--- 5. |[g쐬 ;
   proc report data=RES_CAT nowd ;
      column LABEL _NAME_ _RES1 _RES2 ;
      define LABEL  / order "" ;
      define _NAME_ / display "JeS" ;
      define _RES1  / display "1" style={just=r} ;
      define _RES2  / display "2" style={just=r} ;
   run ;
%mend SUM_CAT ;

proc format ;
   value GENDERF 1="Male" 2="Female" ;
run ;

%SUM_CAT(DATA=HAIKEI,GRP=TREAT,VAR=GENDER,VARLABEL=Gender,VARF=GENDERF) ;

*--- AϐƃJeSϐ݂|[g̍쐬 ;
%macro SUM_TABLE(DATA=,GRP=,GRPF=,VAR=,VARLABEL=,VARF=,VARFLAG=,STAT=,STATF=) ;
   *--- 1. ϐ̃JEg,ϐ^CṽtO,x,tH[}bg̒o ;
   %let I = 1 ;
   %do %while(%scan(&VAR,&I) ne %str()) ;
      %let VAR_N      = &I ;
      %let VAR&I      = %scan(&VAR ,&I) ;
      %let VARF&I     = %scan(&VARF,&I,%str( )) ;
      %let VARFLAG&I  = %scan(&VARFLAG,&I,%str( )) ;
      %let VARLABEL&I = %scan(&VARLABEL,&I,%str(,)) ;
      %let I = %eval(&I + 1) ;
   %end ; %put &VAR_N ;
   *--- 2. vʂ̃JEg ;
   %let J = 1 ;
   %do %while(%scan(&STAT,&J) ne %str()) ;
      %let STAT_N = &J ;
      %let STAT&J  = %scan(&STAT ,&J) ;
      %let STATF&J = %scan(&STATF,&J,%str( )) ;
      %let J = %eval(&J + 1) ;
   %end ;
   *--- 3. ϐ1ʂ쐬ďc ;
   %do K = 1 %to &VAR_N ;
      %if &&VARFLAG&K = 1 %then %do ; *--- Aϐ̏ ;
         *--- 4. v񓝌vʂ̎Zo ;
         proc summary data=&DATA nway ;
             class &GRP ;
             var &&VAR&K ;
             output out=_OUT(drop=_FREQ_ _TYPE_)
             %do L = 1 %to &STAT_N ;
                &&STAT&L = &&STAT&L
             %end ;;
         run ;
         *--- 5. f[^Zbg̓]u: v񓝌vʂc,eQɓWJ ;
         proc transpose data=_OUT out=_OUT_T prefix=GRP ;
            var %do M = 1 %to &STAT_N ; &&STAT&M %end ;;
            id &GRP ;
         run ;
         *--- 6. tH[}bg̊蓖Ăƕϐւ̕ϊ ;
         data _RES ;
            length LABEL _NAME_ _RES1 _RES2 $30. ;
            set _OUT_T ;
            LABEL = "&&VARLABEL&K" ;
            %do N = 1 %to &STAT_N ;
               %if &&STAT&N = n %then %do ;
                  if _NAME_ = "n" then do ;
                     _RES1 = put(GRP1,best.) ;
                     _RES2 = put(GRP2,best.) ;
                  end ;
               %end ;
               %else %do ;
                  if _NAME_ = "&&STAT&N" then do ;
                     _RES1 = put(GRP1,%scan(&&VARF&K,1,.).%eval(%scan(&&VARF&K,2,.)+&&STATF&N)) ;
                     _RES2 = put(GRP2,%scan(&&VARF&K,1,.).%eval(%scan(&&VARF&K,2,.)+&&STATF&N)) ;
                  end ;
               %end ;
            %end ;
            keep LABEL _NAME_ _RES1 _RES2 ;
         run ;
      %end ;
      %else %if &&VARFLAG&K = 2 %then %do ; *--- JeSϐ̏ ;
         *--- 7. ᐔƃp[ZgZo ;
         ods listing close ;
         proc tabulate data=&DATA out=_OUT ;
            class &GRP &&VAR&K ;
            table &GRP,&&VAR&K*(n rowpctn)  ;
         run ;
         ods listing ;
         *--- 8. N(%)Ƃ邽߂ɕϐɕϊ ;
         data _OUT2 ;
            set _OUT ;
            _RES=put(N,best.)||"("||put(pctn_10,5.1)||")" ;
         run ;
         proc sort data=_OUT2 ; by &&VAR&K ; run ;
         *--- 9. f[^Zbg̓]u: N(%)c,eQɓWJ ;
         proc transpose data=_OUT2 out=_OUT_T prefix=_RES ;
            by &&VAR&K ;
            var _RES ;
            id &GRP ;
         run ;
         *--- 10. eJeSւ̃tH[}bg̊蓖 ;
         data _RES ;
            length LABEL _NAME_ $30. ;
            LABEL="&&VARLABEL&K" ;
            set _OUT_T ;
            _NAME_ = left(put(&&VAR&K,&&VARF&K...)) ;
            keep LABEL _NAME_ _RES1 _RES2 ; 
         run ;
      %end ;
      *--- 11. ϐ̌ʂc ;
      data RES ;
         set %if &K > 1 %then RES ; _RES(in=_R) ;
         if _R then ORDER = &K ;
         _RES1 = trim(right(_RES1)) ;
         _RES2 = trim(right(_RES2)) ;
      run ;
   %end ;
   *--- 12. |[g쐬 ;
   proc report data=RES nowd ;
      column ORDER LABEL _NAME_ _RES1 _RES2 ;
      define ORDER  / order noprint ;
      define LABEL  / order "" ;
      define _NAME_ / display "JeS" ;
      define _RES1  / display "1" ;
      define _RES2  / display "2" ;
   run ;
%mend SUM_TABLE ;

proc format ;
   value GENDERF 1="Male" 2="Female" ;
   value SMOKEF 1="Yes" 2="No" ;
run ;

%SUM_TABLE(
   DATA     = HAIKEI,
   GRP      = TREAT,
   GRPF     = TREATF,
   VAR      = %str(AGE  GENDER  SMOKE  WEIGHT  FPG),
   VARLABEL = %str(Age(years), Gender, Smoke, Weight(kg), Fasting Plasma Glucose(mg/dL)),
   VARF     = %str(8. GENDERF SMOKEF 8.1 8.),
   VARFLAG  = %str(1  2       2      1   1 ),
   STAT     = %str(n mean stddev min median max),
   STATF    = %str(0 1    2      0   1      0 )) ;

*--- ODS̏o͐ǉ ;
%macro SUM_TABLE_ODS(DATA=,GRP=,GRPF=,VAR=,VARLABEL=,VARF=,VARFLAG=,STAT=,STATF=,ODSTYPE=,STYLE=) ;
   *--- 1. ϐ̃JEg,ϐ^CṽtO,x,tH[}bg̒o ;
   %let I = 1 ;
   %do %while(%scan(&VAR,&I) ne %str()) ;
      %let VAR_N      = &I ;
      %let VAR&I      = %scan(&VAR ,&I) ;
      %let VARF&I     = %scan(&VARF,&I,%str( )) ;
      %let VARFLAG&I  = %scan(&VARFLAG,&I,%str( )) ;
      %let VARLABEL&I = %scan(&VARLABEL,&I,%str(,)) ;
      %let I = %eval(&I + 1) ;
   %end ; %put &VAR_N ;
   *--- 2. vʂ̃JEg ;
   %let J = 1 ;
   %do %while(%scan(&STAT,&J) ne %str()) ;
      %let STAT_N = &J ;
      %let STAT&J  = %scan(&STAT ,&J) ;
      %let STATF&J = %scan(&STATF,&J,%str( )) ;
      %let J = %eval(&J + 1) ;
   %end ;
   *--- 3. ϐ1ʂ쐬ďc ;
   %do K = 1 %to &VAR_N ;
      %if &&VARFLAG&K = 1 %then %do ; *--- Aϐ̏ ;
         *--- 4. v񓝌vʂ̎Zo ;
         proc summary data=&DATA nway ;
             class &GRP ;
             var &&VAR&K ;
             output out=_OUT(drop=_FREQ_ _TYPE_)
             %do L = 1 %to &STAT_N ;
                &&STAT&L = &&STAT&L
             %end ;;
         run ;
         *--- 5. f[^Zbg̓]u: v񓝌vʂc,eQɓWJ ;
         proc transpose data=_OUT out=_OUT_T prefix=GRP ;
            var %do M = 1 %to &STAT_N ; &&STAT&M %end ;;
            id &GRP ;
         run ;
         *--- 6. tH[}bg̊蓖Ăƕϐւ̕ϊ ;
         data _RES ;
            length LABEL _NAME_ _RES1 _RES2 $30. ;
            set _OUT_T ;
            LABEL = "&&VARLABEL&K" ;
            %do N = 1 %to &STAT_N ;
               %if &&STAT&N = n %then %do ;
                  if _NAME_ = "n" then do ;
                     _RES1 = put(GRP1,best.) ;
                     _RES2 = put(GRP2,best.) ;
                  end ;
               %end ;
               %else %do ;
                  if _NAME_ = "&&STAT&N" then do ;
                     _RES1 = put(GRP1,%scan(&&VARF&K,1,.).%eval(%scan(&&VARF&K,2,.)+&&STATF&N)) ;
                     _RES2 = put(GRP2,%scan(&&VARF&K,1,.).%eval(%scan(&&VARF&K,2,.)+&&STATF&N)) ;
                  end ;
               %end ;
            %end ;
            keep LABEL _NAME_ _RES1 _RES2 ;
         run ;
      %end ;
      %else %if &&VARFLAG&K = 2 %then %do ; *--- JeSϐ̏ ;
         *--- 7. ᐔƃp[ZgZo ;
         ods listing close ;
         proc tabulate data=&DATA out=_OUT ;
            class &GRP &&VAR&K ;
            table &GRP,&&VAR&K*(n rowpctn)  ;
         run ;
         ods listing ;
         *--- 8. N(%)Ƃ邽߂ɕϐɕϊ ;
         data _OUT2 ;
            set _OUT ;
            _RES=put(N,best.)||"("||put(pctn_10,5.1)||")" ;
         run ;
         proc sort data=_OUT2 ; by &&VAR&K ; run ;
         *--- 9. f[^Zbg̓]u: N(%)c,eQɓWJ ;
         proc transpose data=_OUT2 out=_OUT_T prefix=_RES ;
            by &&VAR&K ;
            var _RES ;
            id &GRP ;
         run ;
         *--- 10. eJeSւ̃tH[}bg̊蓖 ;
         data _RES ;
            length LABEL _NAME_ $30. ;
            LABEL="&&VARLABEL&K" ;
            set _OUT_T ;
            _NAME_ = left(put(&&VAR&K,&&VARF&K...)) ;
            keep LABEL _NAME_ _RES1 _RES2 ; 
         run ;
      %end ;
      *--- 11. ϐ̌ʂc ;
      data RES ;
         set %if &K > 1 %then RES ; _RES(in=_R) ;
         if _R then ORDER = &K ;
         _RES1 = trim(right(_RES1)) ;
         _RES2 = trim(right(_RES2)) ;
      run ;
   %end ;

   *--- ODSo ;
   ods listing close ;
   ods &ODSTYPE file="%sysfunc(pathname(work))\temp.&ODSTYPE"
       %if &STYLE ne %str() %then style=&STYLE ;;
   *--- 12. |[g쐬 ;
   proc report data=RES nowd split="#"
        style(report)={rules=none background=white}
        style(header)={fontfamily="MS Gothic"   fontsize=10pt height=15pt
                       just=c vjust=bottom}
        style(column)={fontfamily="Courier New" fontsize=10pt height=15pt
                       vjust=c rules=none} ;
      column ORDER LABEL _NAME_ _RES1 _RES2 DEF ;
      define ORDER  / order noprint ;
      define LABEL  / order "" ;
      define _NAME_ / display "v/JeS" style={width=120pt} ;
      define _RES1  / display "1" style(column)={just=r} ;
      define _RES2  / display "2" style(column)={just=r} ;
      define DEF    / computed noprint ;

      compute DEF ;
         if LABEL ne "" then do ;
            call define(_ROW_,'style','style={bordertopstyle=solid bordertopwidth=1}') ;
         end ;
      endcomp ;
   run ;

   ods &ODSTYPE close ;
   ods listing ;
%mend SUM_TABLE_ODS ;

proc format ;
   value GENDERF 1="Male" 2="Female" ;
   value SMOKEF 1="Yes" 2="No" ;
run ;

%SUM_TABLE_ODS(
   DATA     = HAIKEI,
   GRP      = TREAT,
   GRPF     = TREATF,
   VAR      = %str(AGE  GENDER  SMOKE  WEIGHT  FPG),
   VARLABEL = %str(Age(years), Gender, Smoke, Weight(kg), Fasting Plasma Glucose(mg/dL)),
   VARF     = %str(8. GENDERF SMOKEF 8.1 8.),
   VARFLAG  = %str(1  2       2      1   1 ),
   STAT     = %str(n mean stddev min median max),
   STATF    = %str(0 1    2      0   1      0 ),
   ODSTYPE  = RTF,
   STYLE    = minimal) ;

*--- X^C̐ ;
%macro REPORT_STYLE(DATA=,GRP=,GRPF=,VAR=,FRAME=,RULES=,FONT=,FSIZE=) ;
   ods listing close ;
   ods rtf file="%sysfunc(pathname(work))\temp.rtf" style=RTF ;
   *--- |[g쐬 ;
   proc tabulate data=&DATA ;
      var &VAR ;
      class &GRP ;
      classlev &GRP / style={fontfamily = "MS Gothic"
                             fontsize   = &FSIZE.pt
                             background = white} ;
      table &VAR=""*(n="N"*f=best. mean="Mean"*f=8.1 stddev="SD"*f=8.2),
            &GRP=""*{style={fontfamily  = "&FONT"
                            fontsize    = &FSIZE.pt
                            background  = white}}
            / style = {frame=&FRAME rules=&RULES}
              box   = {label="" style={background=white}}
              row   = float ;
      keyword n mean stddev / style={fontfamily = "&FONT"
                                     fontsize   = &FSIZE.pt
                                     background = white} ;
      format &GRP &GRPF.. ;
   run ;
   ods rtf close ;
   ods listing ;
%mend REPORT_STYLE ;

proc format ;
   value TRTF 1 = "1" 2 = "2" ;
run ;

%REPORT_STYLE(DATA=HAIKEI,GRP=TREAT,GRPF=TRTF,VAR=WEIGHT,
              FRAME=hsides,RULES=rows,FONT=%str(Courier New),FSIZE=9) ;

*--- 2W{t̐ ;
%macro SUM_TTEST(DATA=,GRP=,GRPF=,VAR=,VARLABEL=,TTEST=) ;
   proc summary data=&DATA nway ; *-- v񓝌vʂ̎Zo ;
      class &GRP ; var &VAR ;
      output out=_OUT(drop=_TYPE_ _FREQ_) n=N mean=MEAN stddev=SD ;
   run ;
   %if &TTEST = 1 %then %do ; *--- 2W{t̎s ;
      ods listing close ;
      ods output Ttests=_TTEST(where=(method="Pooled")) ;
      proc ttest data=HAIKEI ; class &GRP ; var &VAR ; run ;
      ods output close ;
      ods listing ;
      data _OUT ; merge _OUT _TTEST ; run ;
   %end ;
   data _OUT ; *--- ͕ϐx̊i[ ;
      length LABEL $20. ;
      set _OUT ;
      LABEL = "&VARLABEL" ;
   run ;
   options missing=" " ; *--- l̋󔒏o ;
   ods listing close ;
   ods rtf file="%sysfunc(pathname(work))\temp.rtf" style=rtf ; *--- |[g ;
   proc report data=_OUT nowd
               style(report)={frame=hsides rules=rows}
               style(header)={background=white fontfamily="Courier New"}
               style(column)={background=white fontfamily="Courier New"} ;
      column LABEL TREAT N MEAN SD %if &TTEST=1 %then tValue Probt ; _LINE ;
      define LABEL  / order ;
      define TREAT  / display format=&GRPF.. ;
      define N      / display format=best. ;
      define MEAN   / display format=8.1 ;
      define SD     / display format=8.2 ;
      define _LINE  / computed noprint ;
      %if &TTEST=1 %then %do ;
         define tValue / display "t-value" format=8.3 ;
         define Probt  / display "p-value" format=8.3 ;
      %end ;
      compute _LINE ; *--- 1sڂ2sڂ̊Ԃ̌ro͂̐ ;
         if LABEL ne "" then do ;
            call define('_C1_','style','style={borderbottomstyle=none}') ;
            %if &TTEST=1 %then %do ;
               call define('_C6_','style','style={borderbottomstyle=none}') ;
               call define('_C7_','style','style={borderbottomstyle=none}') ;
            %end ;
         end ;
      endcomp ;
   run ;
   ods rtf close ;
   ods listing ;
%mend SUM_TTEST ;

proc format ;
   value TRTABF 1 = "A" 2 = "B" ;
run ;

*--- t肠 ;
%SUM_TTEST(DATA=HAIKEI,GRP=TREAT,GRPF=TRTABF,
            VAR=WEIGHT,VARLABEL=%str(Weight(kg)),TTEST=1) ;

*--- tȂ ;
%SUM_TTEST(DATA=HAIKEI,GRP=TREAT,GRPF=TRTABF,
            VAR=WEIGHT,VARLABEL=%str(Weight(kg)),TTEST=0) ;

*--- 6.10 Ot쐬}N ;

*--- eXgf[^̍쐬 ;
data BPDATA ;
   input EXERCISE ID VISIT DBP SBP @@ ;
   if EXERCISE = 2 then VISIT2 = VISIT + 0.1 ;
                   else VISIT2 = VISIT ;
   label EXERCISE="Exercise" VISIT="Visit" VISIT2="Visit"
         DBP="Diastolic BP (mmHg)" SBP="Systolic BP (mmHg)" ;
cards;
1 1  0 124 164 1 7  0 117 167 1 13 0 105 155 1 19 0 115 167
1 1  1 120 157 1 7  1  79 138 1 13 1  99 129 1 19 1 106 130
1 1  2  98 135 1 7  2  96 134 1 13 2 118 152 1 19 2 107 136
1 1  3  95 137 1 7  3  98 114 1 13 3 122 137 1 19 3  51 144
1 2  0 130 150 1 8  0  90 144 1 14 0 102 148 1 20 0 113 147
1 2  1  98 140 1 8  1  89 130 1 14 1 101 143 1 20 1 108 129
1 2  2  86 166 1 8  2 103 137 1 14 2  65 166 1 20 2  97 109
1 2  3  93 134 1 8  3  96 157 1 14 3  95 134 1 20 3  93 152
1 3  0 131 159 1 9  0 123 161 1 15 0 111 134 1 21 0 101 170
1 3  1 101 144 1 9  1  78 127 1 15 1  98 158 1 21 1 110 133
1 3  2 108 131 1 9  2  94 176 1 15 2  84 134 1 21 2  95 170
1 3  3 120 135 1 9  3  95 112 1 15 3  97 155 1 21 3 107 144
1 4  0 100 140 1 10 0 121 145 1 16 0 116 174 1 22 0 114 173
1 4  1  86 169 1 10 1 121 127 1 16 1 103 155 1 22 1  94 134
1 4  2 107 145 1 10 2  93 142 1 16 2  79 131 1 22 2  99 105
1 4  3  88 133 1 10 3 111 114 1 16 3  96  87 1 22 3 125 127
1 5  0 102 156 1 11 0  96 185 1 17 0 122 179 1 23 0  98 157
1 5  1  82 132 1 11 1  85 163 1 17 1 122 174 1 23 1 105 145
1 5  2 112 148 1 11 2  92 125 1 17 2 109 175 1 23 2 104 118
1 5  3  99 177 1 11 3  80 131 1 17 3 105 146 1 23 3 117 163
1 6  0 122 189 1 12 0 107 139 1 18 0 120 159 1 24 0 120 154
1 6  1  92 105 1 12 1  95 190 1 18 1 125 167 1 24 1  86 130
1 6  2 102 172 1 12 2 112 156 1 18 2  92 121 1 24 2 104 131
1 6  3 120 120 1 12 3 112 111 1 18 3  99 180 1 24 3 122 167
2 25 0 108 160 2 31 0 133 190 2 37 0 104 161 2 43 0 120 152
2 25 1  96 163 2 31 1  95 149 2 37 1  90 145 2 43 1 102 134
2 25 2 113 144 2 31 2 102 143 2 37 2  99 173 2 43 2 112 141
2 25 3  92 134 2 31 3  82 151 2 37 3 120 155 2 43 3 113 121
2 26 0 101 170 2 32 0 116 126 2 38 0 106 175 2 44 0  94 161
2 26 1  81 163 2 32 1  98 190 2 38 1  99 170 2 44 1  80 146
2 26 2  94 135 2 32 2 109 155 2 38 2 127 140 2 44 2  98 148
2 26 3  94 158 2 32 3  95 133 2 38 3 107 191 2 44 3 104 145
2 27 0  99 176 2 33 0 114 165 2 39 0  96 175 2 45 0 119 148
2 27 1  81 186 2 33 1 121 130 2 39 1  86 151 2 45 1 108 144
2 27 2 116 150 2 33 2 108 149 2 39 2 103 132 2 45 2 115 160
2 27 3  98 145 2 33 3 111 125 2 39 3 113 112 2 45 3  95 150
2 28 0 108 133 2 34 0 104 140 2 40 0 124 150 2 46 0  92 178
2 28 1 125 136 2 34 1 128 135 2 40 1  95 154 2 46 1 100 158
2 28 2 110 154 2 34 2  85 122 2 40 2 108 147 2 46 2 111 152
2 28 3  87 157 2 34 3  95 174 2 40 3  88 146 2 46 3 102 160
2 29 0 120 175 2 35 0 111 162 2 41 0 115 134 2 47 0 117 176
2 29 1 102 162 2 35 1 101 107 2 41 1  78 132 2 47 1 113 148
2 29 2 100 145 2 35 2 126 175 2 41 2 102 123 2 47 2 128 141
2 29 3 111 165 2 35 3 121 171 2 41 3 103 181 2 47 3 119 122
2 30 0 108 143 2 36 0 124 179 2 42 0  95 171 2 48 0 118 170
2 30 1  92 154 2 36 1 120 150 2 42 1 143 157 2 48 1  87 143
2 30 2 102 127 2 36 2  95 173 2 42 2  96 158 2 48 2 113 144
2 30 3 115 128 2 36 3  94 122 2 42 3  94 154 2 48 3 115 146
;
run ;

*--- ϒlڐ}쐬}N ;
%macro G_MEAN(DATA=,GRP=,GRPF=,VAR=,X=,XF=,HIGE=both,SYMBOL=1) ;
   ods listing gpath="%sysfunc(pathname(work))" ;
   proc sgplot data=&DATA ;
      vline &X
      / response=&VAR group=&GRP stat=mean limitstat=stddev limits=&HIGE
        markers
        markerattrs=(symbol=%if       &SYMBOL = 1 %then circlefilled ;
                            %else %if &SYMBOL = 2 %then trianglefilled ;) ;
      xaxis type=linear ;
      format &GRP &GRPF.. &X &XF.. ;
   run ;
%mend G_MEAN ;

proc format ;
   value EXEF 1="Yes" 2="No" ;
   value VITF 0="Week 0" 1="Week 4" 2="Week 8" 3="Week 12" ;
run ;

%G_MEAN(DATA   = BPDATA,
        GRP    = EXERCISE,
        GRPF   = EXEF,
        VAR    = SBP,
        X      = VISIT2,
        XF     = VITF,
        HIGE   = both,
        SYMBOL = 2) ;

*--- ϒlڐ}2̕ϐ̏dˍ킹 ;
%macro G_MEAN2(DATA=,GRP=,GRPF=,VAR=,VAR2=,YRANGE=,YRANGE2=,
               X=,XF=,HIGE=both,SYMBOL=1) ;
   ods listing gpath="%sysfunc(pathname(work))" ;
   proc sgplot data=&DATA ;
      vline &X
      / response=&VAR group=&GRP stat=mean limitstat=stddev limits=&HIGE
        markers
        markerattrs=(symbol=%if       &SYMBOL = 1 %then circlefilled ;
                            %else %if &SYMBOL = 2 %then trianglefilled ;) ;
      xaxis type=linear ;
      yaxis values=(&YRANGE) ;
      %if &VAR2 ne %str() %then %do ;
         vline &X
         / response=&VAR2 group=&GRP stat=mean limitstat=stddev limits=&HIGE
           markers y2axis
           markerattrs=(symbol=%if       &SYMBOL = 1 %then circlefilled ;
                               %else %if &SYMBOL = 2 %then trianglefilled ;) ;
         y2axis values=(&YRANGE2) ;
      %end ;
      format &GRP &GRPF.. &X &XF.. ;
   run ;
%mend G_MEAN2 ;

%G_MEAN2(DATA   = BPDATA,
        GRP     = EXERCISE,
        GRPF    = EXEF,
        VAR     = SBP,
        VAR2    = DBP,
        YRANGE  = %str(80 to 180 by 20),
        YRANGE2 = %str(80 to 180 by 20),
        X       = VISIT2,
        XF      = VITF,
        HIGE    = upper,
        SYMBOL  = 2) ;

*--- OtIăOt쐬}N ;
%macro G_MACRO(DATA=,ID=,GRAPH=,GRP=,GRPF=,VAR=,X=,XF=,HIGE=both,SYMBOL=1) ;
   ods listing gpath="%sysfunc(pathname(work))" ;
   %if &GRAPH = 1 %then %do ;       *--- 1. ʐڐ} ;
      proc sort data=&DATA ; by &ID &X ; run ;
      proc sgpanel data=&DATA noautolegend ;
         panelby &GRP / layout=columnlattice ;
         series x=&X y=&VAR / group=&ID lineattrs=(pattern=1 color=black) ;
         rowaxis integer ;
         format &GRP &GRPF.. &X &XF.. ;
      run ;
   %end ;
   %else %if &GRAPH = 2 %then %do ; *--- 2. ϒlڐ} ;
      proc sgplot data=&DATA ;
         vline &X
         / response=&VAR group=&GRP stat=mean limitstat=stddev limits=&HIGE
           markers
           markerattrs=(symbol=%if       &SYMBOL = 1 %then circlefilled ;
                               %else %if &SYMBOL = 2 %then trianglefilled ;) ;
         xaxis type=linear ;
         format &GRP &GRPF.. &X &XF.. ;
      run ;
   %end ;
   %else %if &GRAPH = 3 %then %do ; *--- 3. _Ot ;
      proc sgpanel data=&DATA ;
         panelby &X / layout=columnlattice onepanel ;
         vbar &GRP  / response=&VAR group=&GRP
                      stat=mean ;
         format &GRP &GRPF.. &X &XF.. ;
      run ;
   %end ;
%mend G_MACRO ;

*--- ʐڐ} ;
%G_MACRO(DATA  = BPDATA,
         ID    = ID,
         GRAPH = 1,
         GRP   = EXERCISE,
         GRPF  = EXEF,
         VAR   = SBP,
         X     = VISIT,
         XF    = VITF) ;

*--- ϒlڐ} ;
%G_MACRO(DATA   = BPDATA,
         GRAPH  = 2,
         GRP    = EXERCISE,
         GRPF   = EXEF,
         VAR    = SBP,
         X      = VISIT2,
         XF     = VITF,
         HIGE   = upper,
         SYMBOL = 1) ;

*--- _Ot ;
%G_MACRO(DATA   = BPDATA,
         GRAPH  = 3,
         GRP    = EXERCISE,
         GRPF   = EXEF,
         VAR    = DBP,
         X      = VISIT,
         XF     = VITF,
         HIGE   = upper) ;


