*--- 3.1 gpf[^Zbg ;
data QOL ;
  input GROUP $ QOL EVENT DAY PREDRUG $ DURATION ;
  cards ;
    A  15  1    50  NO    1
    A  13  1   200  NO    3
    A  11  1   250  NO    2
    A  11  1   300  NO    4
    A  10  1   350  NO    2
    A   9  1   400  NO    2
    A   8  1   450  NO    4
    A   8  1   550  NO    2
    A   6  1   600  NO    5
    A   6  1   100  NO    7
    A   4  2   250  NO    4
    A   3  2   500  NO    6
    A   3  2   750  NO    3
    A   3  2   650  NO    7
    A   1  2  1000  NO    8
    A   6  1   150  YES   6
    A   5  1   700  YES   5
    A   4  2   800  YES   7
    A   2  2   900  YES  12
    A   2  2   950  YES  10
    B  13  1   380  NO    9
    B  12  1   880  NO    5
    B  11  1   940  NO    2
    B   4  2    20  NO    7
    B   4  2   560  NO    2
    B   5  1   320  YES  11
    B   5  1   940  YES   3
    B   4  2    80  YES   6
    B   3  2   140  YES   7
    B   3  2   160  YES  13
    B   3  2   240  YES  15
    B   2  2   280  YES   9
    B   2  2   440  YES   8
    B   2  2   520  YES   7
    B   2  2   620  YES   9
    B   2  2   740  YES   8
    B   2  2   860  YES   2
    B   1  2   880  YES  10
    B   0  2   920  YES   8
    B   0  2   960  YES   4
    C   9  1   170  NO    1
    C   7  1   290  NO    4
    C   5  1   430  NO    2
    C   3  2   610  NO    4
    C   2  2   110  NO    5
    C   2  2   410  NO    2
    C   1  2   530  NO    7
    C   1  2   580  NO    2
    C   0  2   810  NO    3
    C   0  2   990  NO   10
    C   6  1    30  YES   1
    C   5  1   830  YES   6
    C   3  2    70  YES  16
    C   2  2   310  YES   9
    C   2  2   370  YES  18
    C   1  2   490  YES   7
    C   1  2   690  YES  10
    C   0  2   730  YES   3
    C   0  2   770  YES  12
    C   0  2   910  YES   8
  ;
run ;

*************************************************;

*--- 3.2 SASɂ铝v̗͂ ;

data MYDATA ;
  set   QOL ;
  where GROUP="A" ;
run ;

proc print data=MYDATA ;
  var QOL ;   *--- o͂ϐ ;
run ;

title "qXgOƖx" ;
proc sgplot data=MYDATA ;
  histogram QOL ;               *--- qXgO ;
  density   QOL / type=kernel ; *--- xȐ ;
run ;

title "_Ot";
proc sgplot data=MYDATA ;
  vbar PREDRUG ;
run ;
title "" ;      *--- ^Cg ;

proc univariate data=MYDATA ;
  var QOL ;  *--- v񓝌vʂ߂ϐ ;
run ;

proc univariate data=MYDATA ;
  class PREDRUG ; *--- JeSϐ ;
  var   QOL ;     *--- v񓝌vʂ߂ϐ ;
run ;

title "Ђ}" ;
proc sgplot data=MYDATA ;
  vbox QOL ;    *--- hbox ɂƉɂȂ ;
run ; 
title "" ;      *--- ^Cg ;

proc univariate data=MYDATA mu0=3 ;  *--- ς 3 ǂ ;
  var QOL ;                          *--- ̑ΏۂƂϐ ;
run ;

ods html file="C:\temp\t@C.html" ;   *--- html ;
title "v񓝌v" ;
proc univariate data=MYDATA ;
    var QOL ;
run;
ods html close;

ods rtf file="C:\temp\t@C.rtf" ;     *--- rtf(WORD) ;
title "v񓝌v" ;
proc univariate data=MYDATA ;
    var QOL ;
run;
ods rtf close ;

ods pdf file="C:\temp\t@C.pdf" ;     *--- pdf ;
title "v񓝌v" ;
proc univariate data=MYDATA ;
    var QOL ;
run;
ods pdf close ;

ods rtf file="C:\temp\t@C.rtf" ;     *--- pdflɏo͉ ;
title "x" ;
  proc sgplot data=MYDATA ;
    density QOL / type=kernel ;
  run ;
ods rtf close;

filename mygraph "c:\temp\t@C.emf" ; *--- emf t@C;
goptions reset=all gsfname=mygraph device=emf ;
  title "x" ;
  proc sgplot data=MYDATA ;
    density QOL / type=kernel ;
  run ;
filename mygraph clear ;

ods graphics on / imagefmt=emf ;

title "" ;      *--- ^Cg ;

ods output Moments=MYOUTPUT ;
  proc univariate data=MYDATA ; 
    var QOL ;
  run;
ods output close ;

ods trace on /listing;        *--- vʂ̃xo͂閽 ;
proc univariate data=MYDATA ;
  var QOL ;
run ;

ods trace off ;

ods output TestsForLocation=TTEST(where=(Test="Student  t ")) ;
  proc univariate data=MYDATA ; 
    var QOL ;
  run;
ods output close ;

proc ttest data=MYDATA h0=3 sides=2 ;   *--- sides=2ij ;
  var QOL ;
run ;

proc ttest data=MYDATA h0=3 sides=l ;   *--- sides=lij ;
  var QOL ;
run ;

proc ttest data=MYDATA h0=3 sides=u ;   *--- sides=ui㑤j ;
  var QOL ;
run ;

quit ;

*************************************************;

*--- 3.3 Uz}CAC֌W ;

data MYDATA ;
  set   QOL ;
  where GROUP="A" ;
run ;

proc means data=MYDATA nonobs ;
  class GROUP ;
  var   DURATION QOL ;
run ;

title "Uz}Ƒ֌W" ;
proc sgplot data=MYDATA ;
  scatter x=DURATION y=QOL ; *--- Uz}   ;
  reg     x=DURATION y=QOL ; *--- A ;
run ;

proc reg data=MYDATA ;
  model QOL = DURATION ;
run ;

proc corr data=MYDATA pearson spearman ;
  var DURATION QOL ;
run ;

quit ;

*************************************************;

*--- 3.4 ϒl̔rƉA ;

data MYDATA ;
  set   QOL ;
  where GROUP ne "C" ;
run ;

title "_Otiϒlj" ;
proc sgplot data=MYDATA ;
  vbar GROUP / response=QOL stat=mean ;
run ;

title "_Otiϒl}W΍j" ;
proc sgplot data=MYDATA ;
  hbar GROUP / response=QOL stat=mean numstd=1
               limitstat=stddev limits=upper ;
run ;

title "_Ot" ;
proc sgpanel data=MYDATA ;
  panelby PREDRUG / rows=1 columns=2 ;
  vbar GROUP / response=QOL stat=mean numstd=1
               limitstat=stddev limits=upper ;
run ;

title "" ;

proc summary data=MYDATA print ;
  class GROUP ;
  var   QOL ;
run ;

/*
proc means data=MYDATA NONOBS N MEAN STDDEV ;
  class GROUP ; 
  var   QOL ;
run ;
*/

ods graphics on / imagefmt=emf ;
proc ttest data=MYDATA ;
  class GROUP ;
  var   QOL ;
run ;

proc glm data=MYDATA ;
  class GROUP ;
  model QOL = GROUP / solution ss3 ;
run ;

proc glm data=MYDATA ;
  class GROUP ;
  model QOL = GROUP / noint solution ss3 ;
run ;

ods graphics on / imagefmt=emf ;
proc freq data=MYDATA ;
  table GROUP*PREDRUG / nocol nopercent ;
run ;

proc glm data=MYDATA ;
  class   GROUP PREDRUG ;
  model   QOL = GROUP PREDRUG GROUP*PREDRUG / solution ss3 ;
  lsmeans GROUP ;
run ;

proc glm data=MYDATA ;
  class   GROUP ;
  model   QOL = GROUP DURATION GROUP*DURATION / solution ss3 ;
  lsmeans GROUP ;
run ;

proc means data=MYDATA NONOBS N MEAN STDDEV ;
  class GROUP ;
  var   DURATION ;
run ;

proc means data=MYDATA NONOBS N MEAN STDDEV ;
  var DURATION;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP DURATION / solution ;
  lsmeans  GROUP / at DURATION=10 ; *--- 10  ;
  lsmeans  GROUP / at means ;       *--- Ŝ̕ς ;
run ;

ods graphics on / imagefmt=emf ;
proc glm data=MYDATA ;
  class PREDRUG GROUP ;
  model QOL = GROUP PREDRUG GROUP*PREDRUG ;
run ;

ods graphics on / imagefmt=emf ;
proc glm data=MYDATA ;
  class GROUP ;
  model QOL = GROUP DURATION GROUP*DURATION ;
run ;

proc glm data=MYDATA ;   *--- f1 ;
  class   GROUP ;
  model   QOL = GROUP DURATION / solution ss1 ss2 ss3 ;
run ;

proc glm data=MYDATA ;   *--- f2 ;
  class   GROUP ;
  model   QOL = DURATION GROUP / solutio ss1 ss2 ss3 ;
run ;

proc glm data=MYDATA ;   *--- f3 ;
  class   GROUP ;
  model   QOL = GROUP DURATION GROUP*DURATION / solution ss1 ss2 ss3 ;
run ;

ods graphics on / imagefmt=emf ;
proc glm data=MYDATA ;
  class   PREDRUG GROUP ;
  model   QOL = GROUP PREDRUG / solution ss3 ;
  lsmeans GROUP ;
run ;

ods graphics on / imagefmt=emf ;
proc glm data=MYDATA ;
  class   GROUP ;
  model   QOL = GROUP DURATION / solution ss3 ;
  lsmeans GROUP ;
run ;

proc npar1way hl wilcoxon data=MYDATA correct=no ;
  class GROUP ; 
  var   QOL ;
  exact wilcoxon ; 
run ;

data QOL1 ; 
  input GROUP $ X R ; 
  cards ; 
    A    3   1 
    B    5   2 
    A    6   3 
    A    8   4 
    B   11   5 
  ; 
run ; 

proc npar1way data=QOL1 correct=no ; 
  class  GROUP ; 
  var    X  ; 
  exact  wilcoxon ; 
run ;

proc npar1way data=QOL1 correct=yes ; 
  class  GROUP ; 
  var    X  ; 
  exact  wilcoxon ; 
run ;

proc ttest data=MYDATA h0=-1 side=u ;
  class GROUP ;
  var   QOL ;
run ;

proc mixed data=MYDATA ;
  class   GROUP PREDRUG ;
  model   QOL = GROUP / solution ;
  random  PREDRUG ;
run ;

data QOL0 ;
  input PATIENT GROUP TREAT $ PERIOD QOL ;
  cards ;
    1  1  A  1  1
    1  1  B  2  3
    2  1  A  1  2
    2  1  B  2  4
    3  2  B  1  5
    3  2  A  2  4
    4  2  B  1  7
    4  2  A  2  4
  ;
run ;

proc mixed data=QOL0 ;
  class   PATIENT GROUP TREAT PERIOD ;
  model   QOL = GROUP TREAT PERIOD ;
  random  PATIENT(GROUP) ;
  lsmeans TREAT / pdiff;
run ;

proc glm data=QOL0 ;
  class   PATIENT GROUP TREAT PERIOD ;
  model   QOL = GROUP PATIENT(GROUP) TREAT PERIOD / SS3 ;
  test    H=GROUP  E=PATIENT(GROUP) ;
  lsmeans TREAT / pdiff ;
run ;

ods graphics on / imagefmt=emf ;
proc genmod data=MYDATA ;
  class GROUP ;
  model QOL = GROUP / dist=normal ;
  bayes seed=777 ;
run;
ods graphics off ;

quit ;

*************************************************;

*--- 3.5 2lf[^̔rƃWXeBbNA ;

data MYDATA ;
  set   QOL ;
  where GROUP ne "C" ;
run ;

proc format ;
  value EVENTF 1="Yes" 2="No" ;
run ;

title "_Ot" ;
proc sgplot data=MYDATA ;
  hbar   GROUP / GROUP=EVENT ;
  format EVENT EVENTF. ;
run ;

title "_Ot" ;
proc sgpanel data=MYDATA ;
  panelby PREDRUG / rows=2 columns=1 ;
  hbar    GROUP / GROUP=EVENT ;
  format  EVENT EVENTF. ;
run ;

ods output CrossTabFreqs=OUT1(where=(GROUP ne "" and EVENT ne .)) ;
proc freq data=MYDATA ;
  table GROUP*EVENT / nopercent nocol ;
run ;
ods output close ;

title "_OtiP̗Lj" ;
proc sgplot data=OUT1 ;
  hbar   GROUP / GROUP=EVENT freq=ROWPERCENT ; 
  format EVENT EVENTF. ;
run ;

title "" ;

proc freq data=MYDATA ;
  tables GROUP*EVENT / riskdiff relrisk nocol nopercent ;
  exact  or ;
  format EVENT EVENTF. ;
run ;

data MYFREQ ; 
  input GROUP $ YN ; 
  cards ; 
    A 2
    A 1
    A 1
    B 1
    B 2
  ; 
run ;

proc format ;
  value YNF 1="Male"
            2="Female" ;
run ;

proc freq data=MYFREQ order=data ;
  tables GROUP*YN;
  format YN YNF. ;
run ;

proc freq data=MYDATA order=formatted ;
  tables GROUP*EVENT / riskdiff relrisk nocol nopercent ;
  exact  or ;
  format EVENT EVENTF. ;
run ;

proc freq data=MYDATA ;
  tables GROUP*EVENT / chisq ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ;
  class  GROUP / ref=last param=ref ;
  model  EVENT = GROUP / expb ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ;
  class  GROUP / param=glm ;
  model  EVENT = GROUP / expb noint ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ;
  model  EVENT = DURATION / expb ;
  units  DURATION=5 ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ;
  class  GROUP PREDRUG / ref=last param=ref ;
  model  EVENT = GROUP PREDRUG / expb ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ; 
  class  GROUP / ref=last param=ref ;
  model  EVENT = GROUP DURATION / expb ;
  format EVENT EVENTF. ;
run ;

proc sort data=MYDATA ;
  by PREDRUG ;
run ;

proc freq data=MYDATA order=internal ;
  by     PREDRUG ;
  tables GROUP*EVENT / riskdiff relrisk nocol nopercent ;
  exact  or ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ;
  class  GROUP PREDRUG / ref=last param=ref ;
  model  EVENT = GROUP PREDRUG GROUP*PREDRUG / expb ;
  format EVENT EVENTF. ;
run ;

proc freq data=MYDATA order=data ;
  tables PREDRUG*GROUP*EVENT / nocol nopercent chisq cmh ;
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA order=internal ; 
  class  GROUP / ref=last param=ref ;
  model  EVENT = GROUP DURATION GROUP*DURATION / expb ;
  format EVENT EVENTF. ;
run ;

data MYFREQ2 ;
  input GROUP $ EVENT $ ;
  cards ;
    A Y
    A N
    A N
    A N
    A N
    B Y
    B Y
    B N
    B N
    B N
  ;
run ;

data MYFREQ3 ;
  input GROUP $ EVENT $ N ;
  cards ;
    A Y 1
    A N 4
    B Y 2
    B N 3
  ;
run ;

proc freq data=MYFREQ3 ;
  weight N ;
  tables GROUP*EVENT ;
run ;

data MYFREQ4 ;
  input PREDRUG $ GROUP $
        EVENT     NTOTAL ;
  cards ; 
    Y A  2  5
    Y B  2 13
    N A 10 15
    N B  3  5
  ;
run ;

proc logistic data=MYFREQ4 order=data ;
  class GROUP / ref=last param=ref ;
  model EVENT/NTOTAL = GROUP / expb ;
run ;

data MYFREQ5 ;
  input PREDRUG $  GROUP $
        EVENTYN $ N    ;
  cards ; 
    Y A Y  2
    Y A N  3
    Y B Y  2
    Y B N 13
    N A Y 10
    N A N  5
    N B Y  3
    N B N  2
  ;
run ;

proc logistic data=MYFREQ5 order=data ;
  freq  N ;
  class GROUP / ref=last param=ref ;
  model EVENTYN = GROUP / expb ;
run ;

proc freq data=MYDATA ;
  tables GROUP*EVENT / riskdiff(margin=0.1 method=FM noninf column=1)
                       alpha=0.025 ; 
  format EVENT EVENTF. ;
run ;

proc logistic data=MYDATA descending ;
  model GROUP = QOL / outroc=ROC ;
run ;

data ROC (keep=X Y) ;
  set ROC ;
  X = 100*_1MSPEC_ ; *--- 1-ٓx ;
  Y = 100*_SENSIT_ ; *--- x ;
run ;

proc sgplot data=ROC ;
  series x=X y=Y ;
run ;

ods graphics on ;
proc genmod data=MYDATA order=internal ;
  class GROUP ;
  model EVENT = GROUP / dist=bin link=logit ;
  bayes seed=777 ;
run;
ods graphics off ;

quit ;

*************************************************;

*--- 3.6 ԉ ;

data MYDATA ;
  set   QOL ;
  where GROUP ne "C" ;
run ;

ods graphics on ;
proc lifetest data=MYDATA plots=(s) ;
  time   DAY * EVENT(2) ;  * ώ@*Cxg̗L\ϐ ;
  strata GROUP ;           * Q\ϐ ;
run;
ods graphics off ;

proc lifetest data=MYDATA ;
  time   DAY * EVENT(2) ;  * ώ@*Cxg̗L\ϐ ;
  strata GROUP ;           * Q\ϐ ;
run;

proc phreg data=MYDATA;
  class GROUP ;
  model DAY * EVENT(2) = GROUP / ties=exact;
run ;

proc phreg data=MYDATA;
  class GROUP ;
  model DAY * EVENT(2) = GROUP / ties=exact ;
  hazardratio GROUP / cl=wald ;
run ;

proc phreg data=MYDATA;
  model DAY * EVENT(2) = DURATION / ties=exact;
run ;

proc phreg data=MYDATA;
  class GROUP PREDRUG ;
  model DAY * EVENT(2) = GROUP PREDRUG / ties=exact;
run ;

proc phreg data=MYDATA;
  class GROUP ;
  model DAY * EVENT(2) = GROUP DURATION / ties=exact;
run ;

proc sort data=MYDATA ;
  by PREDRUG ;
run ;

proc phreg data=MYDATA;
  by    PREDRUG ;
  class GROUP ;
  model DAY * EVENT(2) = GROUP / ties=exact;
run ;

proc phreg data=MYDATA ;
  class GROUP PREDRUG ;
  model DAY * EVENT(2) = GROUP PREDRUG GROUP*PREDRUG ;
run ;

proc phreg data=MYDATA;
  class GROUP ;
  model DAY * EVENT(2) = GROUP DURATION GROUP*DURATION / ties=exact;
run ;

data QOL2 ;
  input ID GROUP $ EVENT START END DIFF STRATUM ;
  cards ;
    1 A 1 0 1 1 1
    1 A 1 1 2 1 2
    1 A 2 2 4 2 3
    2 A 1 0 6 6 1
    2 A 1 6 8 2 2
    3 B 2 0 3 3 1
    4 B 1 0 5 5 1
    4 B 2 5 7 2 2
    5 B 1 0 9 9 1
  ;
run ;

data IN ;
  GROUP="A" ; output;
  GROUP="B" ; output;
run;

proc phreg data=QOL2 covs(aggregate) ;
  by     GROUP ;
  class  GROUP ;
  model (START,END)*EVENT(2) = GROUP ;
  baseline covariates=IN out=OUT cmf=_all_ ;
  id ID ;
run;

proc print data=OUT ;
run ;

proc phreg data=QOL2 covs(aggregate) ;
  class  GROUP ;
  model (START,END)*EVENT(2) = GROUP ;
  id     ID ;
run ;

proc phreg data=QOL2 covs(aggregate) ;
  class  GROUP ;
  model (START,END)*EVENT(2) = GROUP ;
  strata STRATUM ;
  id     ID ;
run ;

proc phreg data=QOL2 covs(aggregate) ;
  class  GROUP ;
  model  DIFF*EVENT(2) = GROUP ;
  strata STRATUM ;
  id     ID ;
run ;

proc phreg data=QOL2 covs(aggregate) ;
  class  GROUP ;
  model  END*EVENT(2) = GROUP ;
  strata STRATUM ;
  id     ID ;
run ;

data QOL3 ;
  input ID GROUP $ EVENT END STRATUM ;
  cards ;
    1 A 1 1 1
    1 A 1 2 2
    1 A 2 4 3
    2 A 1 6 1
    2 A 1 8 2
    2 A 2 8 3
    3 B 2 3 1
    3 B 2 3 2
    3 B 2 3 3
    4 B 1 5 1
    4 B 2 7 2
    4 B 2 7 3
    5 B 1 9 1
    5 B 2 9 2
    5 B 2 9 3
  ;
run ;

proc phreg data=QOL3 covs(aggregate) ;
  class  GROUP ;
  model  END*EVENT(2) = GROUP ;
  strata STRATUM ;
  id     ID ;
run ;

ods graphics on ;
proc lifetest data=MYDATA plots=(s,lls) ;
  time   DAY * EVENT(2) ;
  strata GROUP ;
run;
ods graphics off ;

proc phreg data=MYDATA;
  class  GROUP ;
  model  DAY * EVENT(2) = GROUP / ties=exact;
  output out=OUT ressch=SCHOENFELD ;
run ;

proc corr data=OUT ;
  var DAY SCHOENFELD ;
run ;

data QOL4 ;
  input ID GROUP $ COUNT TIME ;	
  LOGT = log(TIME) ;
  cards ;
    1 A 2 4
    2 A 2 8
    3 B 0 3
    4 B 1 7
    5 B 1 9
  ;
run ;

proc genmod data=QOL4 ; 
  class GROUP ; 
  model COUNT=GROUP / link=log dist=poisson offset=LOGT ; 
run ; 

ods graphics on ;
proc phreg data=MYDATA ;
  class GROUP ;
  model DAY * EVENT(2) = GROUP ;
  bayes seed=777 ;
run ;
ods graphics off ;

quit ;

*************************************************;

*--- 3.7 3ȏ̖܊Ԃ̔r ;

data MYDATA ;
  set QOL ;
run ;

proc format ;
  value EVENTF 1="Yes" 2="No" ;
run ;

title "_Otiϒl}W΍j" ;
proc sgplot data=MYDATA ;
  hbar GROUP / response=QOL stat=mean ;
  dot  GROUP / response=QOL stat=mean numstd=1
               limitstat=stddev limits=upper ;
run ;

title "_Otiϒl}W΍j" ;
proc sgpanel data=MYDATA ;
  panelby PREDRUG / rows=1 columns=2 ;
  vbar    GROUP   / response=QOL stat=mean numstd=1
                    limitstat=stddev limits=upper ;
  format  EVENT EVENTF. ;
run ;

title "Ђ}" ;
proc sgplot data=MYDATA ;
  hbox QOL / category=GROUP ;
run ;

title "Ђ}" ;
proc sgpanel data=MYDATA ;
  panelby PREDRUG / rows=1 columns=2 ;
  vbox    QOL / category=GROUP ;
run ;

title "_OtiP̗Lj" ;
proc sgplot data=MYDATA ;
  hbar   GROUP / GROUP=EVENT ;
  format EVENT EVENTF. ;
run ;

ods output CrossTabFreqs=OUT1(where=(GROUP ne "" and EVENT ne .)) ;
proc freq data=mydata ;
  table GROUP*EVENT / nopercent nocol ;
run ;
ods output close ;

title "_OtiP̗Lj" ;
proc sgplot data=OUT1 ;
  hbar   GROUP / GROUP=EVENT freq=ROWPERCENT ; 
  format EVENT EVENTF. ;
run ;

ods output CrossTabFreqs=OUT2(where=(GROUP ne "" and EVENT ne .)) ;
proc freq data=mydata ;
  table  PREDRUG*GROUP*EVENT / nopercent nocol ;
run ;
ods output close ;

title "_OtiP̗Lj" ;
proc sgpanel data=OUT2 ;
  panelby PREDRUG / rows=1 columns=2 ;
  vbar    GROUP   / GROUP=EVENT freq=ROWPERCENT ;
  format  EVENT EVENTF. ;
run ;

title "";

proc means data=MYDATA nonobs n mean stddev min max fw=4;
  class GROUP ;
  var   QOL ;
run ;

proc means data=MYDATA nonobs n mean stddev min max fw=4;
  class PREDRUG GROUP ;
  var   QOL ;
run ;

proc freq data=MYDATA ;
  table  GROUP*EVENT   / nopercent nocol ;
  format EVENT EVENTF. ;
run ;

proc freq data=MYDATA ;
  table  PREDRUG*GROUP*EVENT / nopercent nocol ;
  format EVENT EVENTF. ;
run ;

proc glm data=MYDATA ;
  class GROUP ;
  model QOL = GROUP / ss3 ;
run ;

proc freq data=MYDATA ;
  table  GROUP*QOL   / nopercent nocol cmh2 scores=rank ;
run ;

proc freq data=MYDATA ;
  table  GROUP*EVENT   / nopercent nocol chisq ;
  format EVENT EVENTF. ;
run ;

proc ttest data=MYDATA ;
  where GROUP in ("A","B") ; class GROUP ; var QOL ;
proc ttest data=MYDATA ;
  where GROUP in ("A","C") ; class GROUP ; var QOL ;
proc ttest data=MYDATA ;
  where GROUP in ("B","C") ; class GROUP ; var QOL ;
run ;

proc freq data=MYDATA ;
  where GROUP in ("A","B") ; tables GROUP*EVENT / chisq ;
proc freq data=MYDATA ;
  where GROUP in ("A","C") ; tables GROUP*EVENT / chisq ;
proc freq data=MYDATA ;
  where GROUP in ("B","C") ; tables GROUP*EVENT / chisq ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution noint ;
  estimate "Δ䌟" GROUP 1  0 -1 / e ;
run ;

proc logistic data=MYDATA order=internal ;
  class    GROUP EVENT / param=glm ;
  model    EVENT = GROUP / noint expb ;
  contrast "Δ䌟" GROUP 1  0 -1 / e ;
  format   EVENT EVENTF. ;
run ;

proc freq data=MYDATA ;
  table  GROUP*EVENT / trend ;
  format EVENT EVENTF. ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  estimate "Δ䌟" GROUP 2 -1 -1 / e ;
  estimate "Δ䌟" GROUP 1  0 -1 / e ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  estimate "Δ䌟" INT   0 
                      GROUP 1  0 -1 / e ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  estimate "Δ䌟" GROUP 1  0 -1 / e ;
run ;

proc phreg data=MYDATA;
  class    GROUP ;
  model    DAY * EVENT(2) = GROUP / ties=exact;
  contrast "Δ䌟" GROUP 1 -1 / e ;
run ;

proc mixed data=MYDATA ;
  class    GROUP PREDRUG ;
  model    QOL = GROUP*PREDRUG / solution noint ;
  estimate "OÂȂ̑w"
           GROUP*PREDRUG 1 0 1 0 -2 0 / e ;
run ;

proc logistic data=MYDATA order=internal ;
  class    GROUP EVENT PREDRUG / param=glm ;
  model    EVENT = GROUP*PREDRUG / noint expb ;
  contrast "OÂȂ̑w"
           GROUP*PREDRUG 1 0 1 0 -2 0 / e ;
  format   EVENT EVENTF. ;
run ;

proc mixed data=MYDATA ;
  class    GROUP PREDRUG ;
  model    QOL = GROUP*PREDRUG / solution noint ;
  estimate "OÂȂ̑w"
           GROUP*PREDRUG 1 0 1 0 -2 0 / divisor=2 ;
run ;

proc logistic data=MYDATA order=data ;
  class    GROUP EVENT PREDRUG / param=glm ;
  model    EVENT = GROUP*PREDRUG / noint expb ;
  contrast "ΐIbYɊւX"
           GROUP*PREDRUG 1 -1 1 -1 -2 2 / e ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  lsmeans  GROUP / diff=control("C") ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution noint ;
  estimate "A vs C" GROUP 1  0 -1 ;
  estimate "B vs C" GROUP 0  1 -1 ;
run ;

data PVALUE ;
  input TEST $ RAW_P ;
  cards ;
    AvsC 0.0006
    BvsC 0.1794
  ;
run ;

proc multtest pdata=PVALUE bon sid out=OUTDATA ;
run ;

proc print data=OUTDATA ;
run ;

data _null_;
  call symput('bon_a', 0.05/2           );
  call symput('sid_a', 1-(1-0.05)**(1/2));
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  lsmeans  GROUP / diff=control("C") alpha=&bon_a. cl ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  lsmeans  GROUP / diff=control("C") adjust=bon cl ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  lsmeans  GROUP / diff=control("C") adjust=dunnett cl ;
run ;

proc mixed data=MYDATA ;
  class    GROUP ;
  model    QOL = GROUP / solution ;
  lsmeans  GROUP / adjust=tukey cl ;
run ;

quit ;

ods graphics on ;
proc seqdesign plots=all ;
  Pocock1: design method=poc nstages=4 alpha=0.025 alt=upper ;
run ;
ods graphics off ;

data alpha ;
  alpha = 1-probnorm(2.36129) ;
proc print;
run ;

proc seqdesign boundaryscale=pvalue ;
  Pocock1: design method=poc nstages=4 alpha=0.025 alt=upper ;
run ;

ods graphics on ;
proc seqdesign plots=all ;
  OBrienFleming1: design method=obf nstages=4 alpha=0.025 alt=upper ;
run;
ods graphics off ;

ods graphics on ;
proc seqdesign plots=all ;
  Pocock2:        design method=poc nstages=4 alpha=0.025 alt=lower ;
  OBrienFleming2: design method=obf nstages=4 alpha=0.025 alt=lower ;
  Pocock3:        design method=poc nstages=4 alpha=0.025 ;
  OBrienFleming3: design method=obf nstages=4 alpha=0.025 ;
run;
ods graphics off ;

ods graphics on ;
proc seqdesign plots=all errspend ;
  Pocock:        design method=errfuncpoc nstages=4 info=cum(0.2,0.5,0.8,1.0) alpha=0.025 alt=upper ;
  OBrienFleming: design method=errfuncobf nstages=4 info=cum(0.2,0.5,0.8,1.0) alpha=0.025 alt=upper ;
run;
ods graphics off ;

*================================================;

*--- 3.8 ᐔ݌v ;

proc power;
  onesamplemeans 
  mean   = 3
  stddev = 4
  alpha  = 0.05
  power  = 0.8
  ntotal =  . ;
run ;

proc power;
  onesamplemeans 
  mean   = 3
  stddev = 4
  alpha  = 0.05
  power  =  .
  ntotal = 20 ;
run ;

proc power;
  pairedmeans
  test     = diff
  meandiff = 3
  stddev   = 4 
  alpha    = 0.05
  corr     = 0.6 
  power    = 0.8
  npairs   =  . ;
run ;

proc power ;
  twosamplemeans
  test     = diff
  meandiff = 3
  stddev   = 4
  alpha    = 0.05
  power    = 0.8
  ntotal   =  . ;
run ;

proc power ;
  twosamplemeans
  test      = diff
  meandiff  = 3
  stddev    = 4
  alpha     = 0.05
  power     = 0.8
  npergroup =  . ;
run ;

proc power ;
  twosamplemeans
  test         =  diff
  alpha        =  0.025
  sides        =  u
  groupmeans   = (2,3)
  groupweights = (1,2)
  nulldiff     = -1
  stddev       =  4
  power        =  0.8
  ntotal       =  . ;
run ;

proc power;
  onesamplefreq
  test           = z
  method         = normal
  alpha          =   0.05
  nullproportion =   0.1
  proportion     =   0.2
  power          =   0.8
  ntotal         =    . ;
run ;

proc power;
  twosamplefreq
  test               = pchi
  alpha              = 0.05
  groupproportions   = (0.1 0.2)
  nullproportiondiff = 0.00
  power              = 0.8
  npergroup          =  . ;
run ;

proc power ;
  twosamplefreq
  test               = pchi
  alpha              = 0.025
  sides              = u
  groupproportions   = (0.1 0.2)
  nullproportiondiff = -0.1
  groupweights       = (1,2)
  power              = 0.8
  ntotal             = .  ;
run ;

proc power; 
  twosamplesurvival
  test           = logrank 
  alpha          = 0.05
  curve("A") = (2):(0.9)
  curve("B") = (2):(0.8)
  groupsurvival  = "A" | "B"
  accrualtime    = 0.001 
  followuptime   = 5 
  power          = 0.8
  ntotal         =  . ; 
run ;

proc power; 
  twosamplesurvival
  test                = logrank 
  alpha               = 0.05
  groupsurvexphazards = (0.05268 0.11157)
  accrualtime         = 0.001 
  followuptime        = 5 
  power               = 0.8
  ntotal              =  . ; 
run ;

proc power;
  onewayanova
  test       = contrast
  alpha      = 0.05
  groupmeans = 0 | 10 | 20 | 30
  stddev     = 25
  power      = 0.8
  contrast   = (-3 -1 1 3)
  ntotal     = . ;
run ;

proc power;
  onewayanova
  test         = contrast
  alpha        = 0.05
  groupmeans   = 0 | 10 | 20 | 30
  groupweights = (1 2 2 2)
  stddev       = 25
  power        = 0.8
  contrast     = (-3 -1 1 3)
  ntotal       = . ;
run ;

ods output OUTPUT=MYSAMPLESIZE ;
proc power ;
  twosamplemeans
  test      = diff
  meandiff  = 1 2 3
  stddev    = 4 5 6
  alpha     = 0.05
  power     = 0.8 0.9
  npergroup =  . ;
run ;
ods output close ;

*================================================;

*--- 3.9 ƃV~[V ;

data RDATA01(keep=X) ;
  X = ranuni(777) ;   *--- l 1  ;
run ;

data RDATA02(keep=X) ;
  do I=1 to 5 ;
    X = ranuni(777) ; *--- l 5  ;
    output ;
  end ;
run ;

data RDATA03(keep=X1) ;
  do I=1 to 10;
    X1 = ranuni(100) ;
    output ;
  end ;
run ;

data RDATA04(keep=X2 X3) ;
  do I=1 to 5;
    X2 = ranuni(100) ;
    X3 = ranuni(100) ;
    output ;
  end ;
run ;

data RDATA05(keep=X2 X3) ;
  do I=1 to 5;
    X2 = ranuni(100) ;
    X3 = ranuni(200) ;
    output ;
  end ;
run ;

data RDATA06(keep=X2 X3) ;
  SEED2 = 100 ;
  SEED3 = 200 ;
  do I=1 to 5 ;
    call ranuni(SEED2, X2) ;
    call ranuni(SEED3, X3) ;
    output ;
  end ;
run ;

data X ;
  do I=1 to 10000 ;
     X = ranuni(100) ; output ; end ;
data Y ;
  do I=1 to 10000 ;
     Y = ranuni(200) ; output ; end ;
data RDATA07 ;
  merge X Y ;
run ;
proc gplot data=RDATA07 ;
  plot Y*X ;
run ;

data RDATA08(keep=X1) ;
  call streaminit(100) ;
  do I=1 to 10;
    X1 = rand('UNIFORM') ;
    output ;
  end ;
run ;

data RDATA09(keep=X2 X3) ;
  call streaminit(100) ;
  do I=1 to 5;
    X2 = rand('UNIFORM') ;
    X3 = rand('UNIFORM') ;
    output ;
  end ;
run ;

data RDATA10(keep=X2 X3) ;
  do I=1 to 5;
    call streaminit(100) ;
    X2 = rand('UNIFORM') ;
    call streaminit(200) ;
    X3 = rand('UNIFORM') ;
    output ;
  end ;
run ;

data X ;
  call streaminit(100) ;
  do I=1 to 10000 ;
     X = rand('UNIFORM') ; output ; end ;
data Y ;
  call streaminit(200) ;
  do I=1 to 10000 ;
     Y = rand('UNIFORM') ; output ; end ;
data RDATA11 ;
  merge X Y ;
run ;
proc gplot data=RDATA11 ;
  plot Y*X ;
run ;

data RDATA12 ;
  call streaminit(777) ;
  do I=1 to 5;
    X = rand("HYPER", 40, 3, 20) ;
    Y = rand("TABLE",0.1,0.2,0.3,0.4) ;
    output ;
  end ;
run ;

/*
data RDATA12 ;
  call streaminit(100) ;
  do I=1 to 5;
    A = rand("BERNOULLI", 0.1) ;
    B = rand("BETA", 2, 3) ;
    C = rand("BINOMIAL", 0.4, 50) ;
    D = rand("CAUCHY") ;
    E = rand("CHISQUARE", 6) ;
    F = rand("ERLANG", 7) ;
    G = rand("EXPONENTIAL") ;
    H = rand("F", 8, 9) ;
    I = rand("GAMMA", 10) ;
    J = rand("GEOMETRIC", 0.1) ;
    K = rand("HYPER", 40, 3, 20) ;
    L = rand("LOGNORMAL") ;
    M = rand("NEGBINOMIAL", 0.5, 6) ;
    N = rand("NORMAL", 7, 8) ;
    O = rand("POISSON", 9) ;
    P = rand("T", 10) ;
    Q = rand("TABLE",0.1,0.2,0.3,0.4) ;
    R = rand("TRIANGLE", 5) ;
    S = rand("UNIFORM") ;
    T = rand("WEIBULL", 6, 7) ;
    output ;
  end ;
run ;
*/

data MV ;
  input _TYPE_ $ _NAME_ $ X Y Z ;
  cards ;
    MEAN . 1.0 2.0  3.0
    COV  X 4.0 0.0  8.0
    COV  Y 0.0 9.0  0.0
    COV  Z 8.0 0.0 16.0
  ;
run ;

proc simnormal 
  data    = MV(type=cov)
  out     = RDATA13
  numreal = 1000
  seed    = 777 ;
  var X Y Z ;
run ;

proc corr data=RDATA13 ;
  var X Y Z ;
run ;

data RDATA14 ;
  N = 10000 ;
  call streaminit(777) ;
  do I=1 to N ;
    X = -log(rand('UNIFORM')) ;
    output ;
  end ;
run ;

proc univariate data=RDATA14 ;
  histogram X / cfill=blue 
    midpoints=0 to 12 by 0.1 ;
run ;

data RDATA15 ;
  N = 10000 ;
  call streaminit(777) ;
  do I=1 to N ;
    U = rand('UNIFORM') ;
    if (U < 1/2) then X = sqrt(2*U) ;
    else              X = 2-sqrt(2*(1-U)) ;
    output ;
  end ;
run ;

proc univariate data=RDATA15 ;
  histogram X / cfill=blue 
    midpoints=-1 to 3 by 0.1 ;
run ;

data RDATA16 ;
  I = 1 ;
  N = 10000 ;
  call streaminit(777) ;
  do while (I <= N) ;
    V = 2*rand('UNIFORM') ;
    U = rand('UNIFORM') ;
    if      (0 <= V <= 1) then H = V ;
    else if (1 <  V <= 2) then H = 2-V ;
    else                       H = 0 ;
    if (U <= H) then do ;
      X = V ;
      I = I+1 ;
      output ;
    end ;
  end ;
run ;

proc univariate data=RDATA16 ;
  histogram X / cfill=blue
    midpoints=-1 to 3 by 0.1 ;
run ;

data RDATA17 ;
  N = 10000 ;
  call streaminit(777) ;
  do I=1 to N ;
    X = rand('UNIFORM')+rand('UNIFORM')+rand('UNIFORM')+
        rand('UNIFORM')+rand('UNIFORM')+rand('UNIFORM')+
        rand('UNIFORM')+rand('UNIFORM')+rand('UNIFORM')+
        rand('UNIFORM')+rand('UNIFORM')+rand('UNIFORM')-6 ;
    output ;
  end ;
run ;

proc univariate data=RDATA17 ;
  histogram X / cfill=blue 
    midpoints=-4 to 4 by 0.5 ;
run ;

data SDATA01(keep=COIN) ;
  call streaminit(777) ;
  X = rand('UNIFORM') ;
  if (X > 1/2) then COIN = 1 ; *--- \ ;
  else              COIN = 0 ; *---  ;
run ;

data SDATA02(keep=DICE) ;
  call streaminit(777) ;
  X = rand('UNIFORM') ;
  if      (X < 1/6) then DICE = 1 ;
  else if (X < 2/6) then DICE = 2 ;
  else if (X < 3/6) then DICE = 3 ;
  else if (X < 4/6) then DICE = 4 ;
  else if (X < 5/6) then DICE = 5 ;
  else                   DICE = 6 ;
run ;

data SDATA03(keep=COIN) ;
  call streaminit(777) ;
  COIN = rand("BERNOULLI", 0.5) ;
run ;

data SDATA04(keep=DICE) ;
  call streaminit(777) ;
  DICE = rand("TABLE",1/6,1/6,1/6,1/6,1/6,1/6) ;
run ;

data SDATA05(keep=I COIN) ;
  do I=1 to 4 ;
    COIN = rand("BERNOULLI", 0.5) ;
    output ;
  end ;
run ;

data SDATA06(keep=I DICE) ;
  do I=1 to 4 ;
    DICE = rand("TABLE",1/6,1/6,1/6,1/6,1/6,1/6) ;
    output ;
  end ;
run ;

ods output SUMMARY=SDATA07 ;
proc means data=SDATA06 nonobs sum ;
  var DICE ;
run ;
ods output close ;

data SDATA08(keep=I DICE) ;
  call streaminit(777) ;
  do I=1 to 1000 ;
    do j=1 to 4 ;
      DICE = rand("TABLE",1/6,1/6,1/6,1/6,1/6,1/6) ;
      output ;
    end ;
  end ;
run ;

ods listing close ;
ods output SUMMARY=SDATA09 ;
proc means data=SDATA08 nonobs sum ;
  by  I ;
  var DICE ;
run ;
ods output close ;
ods listing ;

proc means data=SDATA09 nonobs n mean ;
  var DICE_SUM ;
run ;

data NDATA01(keep=I N GROUP QOL);
  call streaminit(777) ;
  array MU(2) M1-M2 ;
  M1=6.5; M2=4.0 ; SIGMA=3.0 ; N=20 ;
  do I=1 to 1000 ;
    do GROUP=1 to 2; 
      do J=1 to N ; 
        QOL = rand("NORMAL", MU(GROUP), SIGMA) ;
        output ;
      end ;
    end ;
  end ;
run ;

ods listing close ;
ods output ttests=RESULT01(where=(method="Pooled")) ;
proc ttest data=NDATA01 ;
  by    I     ;
  class GROUP ;
  var   QOL   ;
run ;
ods output close ;
ods listing ;

data POWER01 ;
  set RESULT01 ;
  if (tValue > 0) and (Probt < 0.05)
  then FLAG = 1 ;   *--- LӍ ;
  else FLAG = 0 ;   *--- LӍȂ ;
run ;

proc freq data=POWER01 ;
  table FLAG ;      *--- FLAG=1 ̊߂ ;
run ;

proc power ;
  twosamplemeans
  test      = diff
  meandiff  = 2.5
  stddev    = 3.0
  alpha     = 0.05
  power     = .
  npergroup = 20 ;
run ;

data NDATA02(keep=I N GROUP EVENT K);
  call streaminit(777) ;
  array PROP(2) P1-P2 ;
  P1=0.4; P2=0.2 ; N=100 ;
  do I=1 to 1000 ;
    do GROUP=1 to 2; 
      X     = rand("BINOMIAL", PROP(GROUP), N) ;
      EVENT = "Y"; K = X   ; output ;
      EVENT = "N"; K = N-X ; output ;
    end ;
  end ;
run ;

ods listing close ;
ods output ChiSq=ChiSq(where=(Statistic="JC 2 l")) ;
proc freq data=NDATA02 ;
  by     I ;
  weight K ;
  tables GROUP*EVENT / chisq ;
run ;
ods output close ;
ods listing ;

ods listing close ;
ods output RiskDiffCol2=RiskDiff(where=(Row="")) ; ;
proc freq data=NDATA02 ;
  by     I ;
  weight K ;
  tables GROUP*EVENT / riskdiff ;
run ;
ods output close ;
ods listing ;

data RESULT02 ;
  merge ChiSq RiskDiff ;
  by    I ;
  keep  I Prob Risk ;
run ;

data POWER02 ;
  set RESULT02 ;
  if  (Risk > 0) and (Prob < 0.05)
  then FLAG = 1 ;   *--- LӍ ;
  else FLAG = 0 ;   *--- LӍȂ ;
run ;

proc freq data=POWER02 ;
  table FLAG ;      *--- FLAG=1 ̊߂ ;
run ;

proc power;
  twosamplefreq
  test               = pchi
  alpha              = 0.05
  groupproportions   = (0.2 0.4)
  nullproportiondiff = 0.00
  power              = .
  npergroup          = 100 ;
run ;

*================================================;

*--- 3.10 xCYv̊b ;

data MYDATA ;
  input Y N ;
  cards ;
    2 5
  ;
run ;

ods graphics on ;
proc mcmc data=MYDATA seed=777 nmc=1000 ;
  parm  THETA 0.5 ;
  prior THETA ~ beta(1, 1) ;
  model Y     ~ binomial(N, theta) ;
run ;
ods graphics off ;

data MYDATA ;
  input Y @@ ;
  cards ;
    19 24 26 27 29
  ;
run ;

ods graphics on ;
proc mcmc data=MYDATA seed=777 nmc=1000 
     outpost=RESULT ;
  parm  mu 25 ;
  prior mu ~ normal(mean=27, var= 9) ;
  model Y  ~ normal(mean=mu, var=16) ;
run ;
ods graphics off ;

data MYDATA ;
  input n y x1 x2 ;
  cards ;
     5  2 1 0
    15 10 1 1
    15  2 0 0
     5  3 0 1
  ;   
run ;

ods graphics on ;
proc mcmc data=MYDATA seed=777 nmc=5000 nbi=5000 thin=5 ;
  parms (beta0 beta1 beta2) 0 ;
  prior beta0 beta1 beta2 ~ normal(0, var = 1000000) ;
  p = logistic(beta0 + beta1*x1 + beta2*x2) ;
  model y ~ binomial(n,p) ;
run ;
ods graphics off ;

data MYDATA ;
  input X Y @@ ;
  cards ;
    1 1  2 2  3 3  4 4  5 5.1
  ;   
run ;

ods graphics on;
proc mcmc data=MYDATA seed=777 nmc=2000
outpost=RESULT monitor=(_parms_ sigma) ;
  array tau[2]   ;
  array beta[2]  ;
  array sigma[2] ;
  parms tau:  1  ;
  parms beta: 0  ;
  beginprior ;
    prior tau1 ~ gamma(0.001, iscale=0.001) ;
    hyper tau2 ~ gamma(0.001, iscale=0.001) ;
    prior beta:~ normal(mean=0, var=1/tau2) ;
    sigma1 = sqrt(1/tau1) ;
    sigma2 = sqrt(1/tau2) ;
  endprior ;
        mu = beta1 + beta2*X ;
  model Y  ~ normal(mu, var=1/tau1) ;
run;
ods graphics off ;
