*** 4 |[g̍쐬 ;
options nodate nonumber ;

*--- 4.1 f[^̓ǂݍ ;
proc format ;
   value TRTF    1 = "A" 2 = "B" ;
   value GENDERF 1 = "j"  2 = ""  ;
   value VISITF  1 = "4T" 2 = "8T" ;
run ;

data WGT ;
   input ID TREAT GENDER VISIT WGT_CHG ABD_CHG @@ ;
   label TREAT = "܌Q" GENDER = "" VISIT = "]_"
         WGT_CHG = "̏dω(kg)" ABD_CHG = "͕ω(cm)";
   format TREAT TRTF. GENDER GENDERF. VISIT VISITF. ;
cards;
 1 1 1 1  0.4 -1.1 16 2 1 1 -1.0 -1.7
 1 1 1 2 -1.8 -1.9 16 2 1 2  0.5 -1.3
 2 1 2 1 -1.4 -0.6 17 2 2 1 -1.0 -1.5
 2 1 2 2 -2.1 -1.4 17 2 2 2 -1.0 -1.2
 3 1 2 1 -2.6 -2.1 18 2 2 1 -2.5 -2.2
 3 1 2 2 -2.2 -2.2 18 2 2 2 .    -1.4
 4 1 2 1 -0.7 -2.2 19 2 1 1 -0.8 -0.2
 4 1 2 2 -2.4 -2.1 19 2 1 2  0.7 -0.7
 5 1 2 1 -1.2 -0.7 20 2 1 1 -0.5 -1.0
 5 1 2 2 -2.6 -2.4 20 2 1 2 -0.7  0.5
 6 1 1 1 -1.0 -2.1 21 2 1 1 -1.4 -0.2
 6 1 1 2 -2.4 -2.1 21 2 1 2 -1.5  0.2
 7 1 2 1 -1.5 -2.8 22 2 2 1 -1.3 -1.5
 7 1 2 2 -1.7 -1.0 22 2 2 2 -1.1 -2.5
 8 1 2 1 -1.9 -2.4 23 2 1 1 -0.7 -0.8
 8 1 2 2 -1.9 -2.3 23 2 1 2 -1.2  0.2
 9 1 2 1 -0.8 -0.6 24 2 2 1 -1.7  0.4
 9 1 2 2 -1.1 -2.0 24 2 2 2 -1.5 -1.8
10 1 2 1 -2.2 -1.9 25 2 2 1 -0.5 -0.5
10 1 2 2 -2.7 -1.9 25 2 2 2 -1.3 -0.7
11 1 2 1 -2.9 -1.4 26 2 2 1 -0.3 -2.4
11 1 2 2 -2.6 -2.4 26 2 2 2 -0.1 -1.1
12 1 2 1 -1.4 -0.6 27 2 2 1 -0.4 -1.2
12 1 2 2 -1.9 -2.2 27 2 2 2 -1.8 -1.3
13 1 1 1 -2.2 -2.7 28 2 1 1 -1.4 -1.1
13 1 1 2 -2.3 -2.8 28 2 1 2  0.4 -2.1
14 1 2 1 -2.2 -2.9 29 2 2 1  0.0 -2.3
14 1 2 2 -3.2 -0.9 29 2 2 2 -2.1 -1.7
15 1 2 1 -1.1 -1.4 30 2 1 1 -1.6 -1.7
15 1 2 2 -1.1 -1.9 30 2 1 2  0.4 -1.5
;
run ; 

proc sort data=WGT ;
   by ID VISIT ;
run ;

*--- 4.2 meansvVW ;
ods output Summary=WGTSUM ;
proc means data=WGT ;
   var WGT_CHG ;
   class VISIT TREAT ;
run ;
ods output close ;

proc print data=WGTSUM noobs label ;
run ;

*--- 4.3 tabulatevVW ;
proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   table TREAT ;
run ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   var   WGT_CHG ;
   table WGT_CHG ;
run ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table TREAT*WGT_CHG ;
   label WGT_CHG="̏d" ;
run ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ABD_CHG ;
   table TREAT*(WGT_CHG ABD_CHG) ;
   label WGT_CHG="̏d"
         ABD_CHG="" ;
run ;

*--- all ;
proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
   label WGT_CHG="̏d" ;
run ;

*--- Descriptive Statistics ;
proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT  ;
   var   WGT_CHG ;
   table TREAT*WGT_CHG*(N*f=8.0 MEAN*f=8.2 PCTN*f=8.2) ;
run ;

*--- Format and label ;
proc format ;
   value TRT2F 1 = "Drug A" 2 = "Drug B" ;
run ;

proc tabulate data=WGT ;
   where  VISIT = 2 ;
   class  TREAT  ;
   var    WGT_CHG ;
   table  (TREAT all)*WGT_CHG*(MEAN*f=8.2) ;
   format TREAT TRT2F. ;
   label  WGT_CHG="̏d" ;
run ;

proc tabulate data=WGT ;
   where    VISIT = 2 ;
   class    TREAT  ;
   var      WGT_CHG ;
   table    (TREAT all)*WGT_CHG=''*(MEAN*f=8.2) ;
   label    TREAT="Group" ;
   keylabel MEAN='Mean (kg)' all='Total' ;
   format   TREAT TRT2F. ;
run ;

*--- WGT_CHGtH[}bg ;
proc format ;
   value WGTF LOW -< 0 = ""
              0 - HIGH = "" ;
run ;

proc tabulate data=WGT ;
   class VISIT TREAT WGT_CHG ;
   table VISIT*TREAT*WGT_CHG=''*N='ᐔ'*f=8.0 ;
   format WGT_CHG WGTF. ;
run ;

*--- sƗ ;
proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table TREAT*WGT_CHG ;
   label  WGT_CHG="̏d" ;
run ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table TREAT,WGT_CHG ;
   label  WGT_CHG="̏d" ;
run ;

proc tabulate data=WGT ;
   where  VISIT = 2 ;
   class  TREAT GENDER ;
   var    WGT_CHG ;
   table  TREAT*GENDER*WGT_CHG ;
   label  WGT_CHG="̏d" ;
run ;

proc tabulate data=WGT ;
   where  VISIT = 2 ;
   class  TREAT GENDER ;
   var    WGT_CHG ;
   table  TREAT,GENDER*WGT_CHG ;
   label  WGT_CHG="̏d" ;
run ;

proc tabulate data=WGT ;
   class  TREAT VISIT GENDER ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
          WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;

*--- order ;
proc tabulate data=WGT order=freq ;
   where  VISIT = 2 ;
   class  GENDER ;
   var    WGT_CHG ;
   table  GENDER,WGT_CHG ;
   label  WGT_CHG="̏d" ;
run ;

*--- rtspace ;
proc tabulate data=WGT ;
   class  VISIT TREAT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',WGT_CHG*(N*f=8.0 MEAN*f=8.2)
          / rtspace=20 ;
run ;

*--- box ;
proc tabulate data=WGT ;
   class  VISIT TREAT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',WGT_CHG*(N*f=8.0 MEAN*f=8.2)
          / rtspace=20 box="]_/" ;
run ;

*--- printmiss ;
proc tabulate data=WGT ;
   class VISIT TREAT WGT_CHG ;
   table VISIT*TREAT*WGT_CHG=''*N='ᐔ'*f=8.0
         / printmiss ;
   format WGT_CHG WGTF. ;
run ;

*--- misstext ;
proc tabulate data=WGT ;
   class VISIT TREAT WGT_CHG ;
   table VISIT*TREAT*WGT_CHG=''*N='ᐔ'*f=8.0
         / printmiss misstext="0" ;
   format WGT_CHG WGTF. ;
run ;

*--- missing ;
proc tabulate data=WGT ;
   class VISIT TREAT WGT_CHG / missing ;
   table VISIT*TREAT*WGT_CHG=''*N='ᐔ'*f=8.0
         / printmiss misstext="0" ;
   format WGT_CHG WGTF. ;
run ;

*--- missing 2 ;
proc format ;
   value WGT2F .        = "l"
               LOW -< 0 = ""
               0 - HIGH = "" ;
run ;

proc tabulate data=WGT ;
   class VISIT TREAT WGT_CHG / missing ;
   table VISIT*TREAT*WGT_CHG=''*N='ᐔ'*f=8.0
         / printmiss misstext="0" ;
   format WGT_CHG WGT2F. ;
run ;

*--- mlf ;
proc format ;
   value WGT3F (multilabel notsorted)
               LOW -< 0   = "< 0kg"
               0   - HIGH = ">= 0kg"
               LOW - -2   = "<= -2kg"
               -2< - HIGH = "> -2kg" ;
run ;

proc tabulate data=WGT ;
   class VISIT TREAT ;
   class WGT_CHG / mlf preloadfmt order=data ;
   table VISIT=''*WGT_CHG='',TREAT=''*N=''*f=8.0
         / printmiss misstext="0" rtspace=30 box="_/̏d" ;
   format WGT_CHG WGT3F. ;
run ;

*--- ܂Ƃ ;
title '̏dƕ͂̕ωʂɊւv񓝌v' ;
proc tabulate data=WGT ;
  class  VISIT TREAT GENDER ;
  var    WGT_CHG ABD_CHG ;
  table  TREAT='܌Q: ',
         VISIT=''*(GENDER='' all),
         (WGT_CHG ABD_CHG)*(N*f=8.0 MEAN*f=8.2 STD*f=8.3)
         / rtspace=20 box='_/' ;
  table  VISIT=''*TREAT=''*(GENDER='' all),
         (WGT_CHG ABD_CHG)*(N*f=8.0 MEAN*f=8.2 STD*f=8.3)
         / rtspace=30 box='_/܌Q/' ;
  label    TREAT='܌Q: ' GENDER='';
  keylabel N='ᐔ' MEAN='ϒl' STD='W΍' all='v' ;
run ;

*--- 4.4 reportvVW ;
*--- display ;
proc report data=WGTSUM nowd headline ;
   column VISIT TREAT WGT_CHG_N  WGT_CHG_Mean WGT_CHG_Stddev
          WGT_CHG_MIN  WGT_CHG_MAX ;
   define VISIT          / order   width=10 ;
   define TREAT          / display width=10 ;
   define WGT_CHG_N      / display format=8.0 ;
   define WGT_CHG_Mean   / display format=8.2 ;
   define WGT_CHG_Stddev / display format=8.3 ;
   define WGT_CHG_MIN    / display format=8.1 ;
   define WGT_CHG_MAX    / display format=8.1 ;
quit ;

*--- Descriptive Statistics ;
proc report data=WGT nowd headline ;
   column VISIT TREAT WGT_CHG,(n mean std min max) ;
   define VISIT   / group width=10 ;
   define TREAT   / group width=10 ;
   define WGT_CHG / analysis format=8.2 ;
quit ;

proc report data=WGT nowd headline ;
   column VISIT TREAT
          ("̏dω(kg)" WGT_CHG=WGT_N WGT_CHG=WGT_MEAN
           WGT_CHG=WGT_SD WGT_CHG=WGT_MIN WGT_CHG=WGT_MAX) ;
   define VISIT    / group width=10 ;
   define TREAT    / group width=10 ;
   define WGT_N    / analysis n    format=8.0 "N" ;
   define WGT_Mean / analysis mean format=8.2 "Mean" ;
   define WGT_SD   / analysis std  format=8.3 "SD" ;
   define WGT_MIN  / analysis min  format=8.1 "Min" ;
   define WGT_MAX  / analysis max  format=8.1 "Max" ;
quit ;

*--- break ;
proc report data=WGT nowd headline ;
   column VISIT TREAT GENDER
          ("̏dω(kg)" WGT_CHG=WGT_N WGT_CHG=WGT_MEAN
           WGT_CHG=WGT_SD WGT_CHG=WGT_MIN WGT_CHG=WGT_MAX) ;
   define VISIT    / group width=10 ;
   define TREAT    / group width=10 ;
   define GENDER   / group width=10 ;
   define WGT_N    / analysis n    format=8.0 "N" ;
   define WGT_Mean / analysis mean format=8.2 "Mean" ;
   define WGT_SD   / analysis std  format=8.3 "SD" ;
   define WGT_MIN  / analysis min  format=8.1 "Min" ;
   define WGT_MAX  / analysis max  format=8.1 "Max" ;

   break after TREAT / dol dul summarize suppress ;
quit ;

*--- compute ;
proc report data=WGT nowd headline split="#" ;
   column ID GENDER TREAT DEMOG VISIT WGT_CHG WGT_G ;
   define ID      / display noprint width=10 ;
   define GENDER  / display noprint width=10 ;
   define TREAT   / display noprint width=10 ;
   define DEMOG   / order computed "ID//܌Q" width=15 ;
   define VISIT   / display width=10 ;
   define WGT_CHG / display width=15 ;
   define WGT_G   / computed "̏dω(g)" width=15 ;

   compute DEMOG / character length=20 ;
      DEMOG = compress(put(ID,best.))       ||"/"||
              compress(put(GENDER,GENDERF.))||"/"||
              compress(put(TREAT,TRTF.)) ;
   endcomp ;

   compute WGT_G ;
      WGT_G = WGT_CHG*1000 ;
   endcomp ;
quit ;

*--- compute+line ;
proc report data=WGT nowd headline ;
   column VISIT TREAT GENDER
          ("̏dω(kg)" WGT_CHG=WGT_N WGT_CHG=WGT_MEAN
           WGT_CHG=WGT_SD WGT_CHG=WGT_MIN WGT_CHG=WGT_MAX) ;
   define VISIT    / group width=10 ;
   define TREAT    / group width=10 ;
   define GENDER   / group width=10 ;
   define WGT_N    / analysis n    format=8.0 "N" ;
   define WGT_Mean / analysis mean format=8.2 "Mean" ;
   define WGT_SD   / analysis std  format=8.3 "SD" ;
   define WGT_MIN  / analysis min  format=8.1 "Min" ;
   define WGT_MAX  / analysis max  format=8.1 "Max" ;

   break after TREAT / dol dul summarize suppress ;
   compute after TREAT ;
       line @22 84*"-" ;
       line "line break after TREAT" ;
       line @22 84*"-" ;
   endcomp ;
quit ;

*--- 4.5 ODS ;

*--- ODS RTF ;
*--- Example 1 ;
options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" bodytitle style=statistical ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
run ;

ods rtf close ;
ods listing ;

*--- Example 2 ;
options orientation=landscape papersize=A4 nodate nonumber ;
ods rtf file="C:\temp\output.rtf" columns=2 style=statistical ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
run ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   ABD_CHG ;
   table (TREAT all)*ABD_CHG ;
run ;

ods rtf close ;

*--- style template ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" bodytitle style=brick ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
run ;

ods rtf close ;
ods listing ;

ods listing close ;
ods rtf file="C:\temp\output.rtf" bodytitle style=gears ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
run ;

ods rtf close ;
ods listing ;

ods listing close ;
ods rtf file="C:\temp\output.rtf" bodytitle style=harvest ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
run ;

ods rtf close ;
ods listing ;

ods listing close ;
ods rtf file="C:\temp\output.rtf" bodytitle style=theme ;

proc tabulate data=WGT ;
   where VISIT = 2 ;
   class TREAT ;
   var   WGT_CHG ;
   table (TREAT all)*WGT_CHG ;
run ;

ods rtf close ;
ods listing ;

*--- ODS tagsets.ExcelXP ;
ods tagsets.excelxp file='test.xml' options(doc='help');
ods tagsets.excelxp close ;

*--- Example 1 ;
ods listing close ;
ods tagsets.excelxp file='C:\temp\test.xls' style=statistical 
    options(embedded_titles    = 'Yes'
            embedded_footnotes = 'Yes'
            sheet_name         = 'Tabulate Procedure 1') ;

title "̏dωʂ̗v񓝌v" ;
footnote "ODS tagsets.ExcelXPtabulatevVW" ;

proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
          WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;

title ; footnote ;
ods tagsets.excelxp close ;
ods listing ;

*--- Example 2 ;
ods listing close ;
ods tagsets.excelxp file='C:\temp\test.xls' style=statistical 
    options(contents           = 'Yes'
            index              = 'Yes'
            sheet_name         = 'V[g1: ̏d'
            embedded_titles    = 'Yes') ;

ods proclabel="Rec1" ;
title "̏dωʂ̗v񓝌v" ;

proc tabulate data=WGT contents="̏dωʂ̗v񓝌v" ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
          WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1)
          / contents="\1" ;
run ;

ods tagsets.excelxp options(sheet_name='V[g2: ') ;

ods proclabel="Rec2" ;
title "͕ωʂ̗v񓝌v" ;

proc tabulate data=WGT contents="͕ωʂ̗v񓝌v" ;
   class  TREAT VISIT ;
   var    ABD_CHG ;
   table  VISIT=''*TREAT='',
          ABD_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1)
          / contents="\2" ;
run ;

title ;
ods tagsets.excelxp close ;
ods listing ;

*--- Example 3 ;
ods listing close ;
ods tagsets.excelxp file='C:\temp\test.xls' style=statistical 
    options(autofilter            = 'all'
            frozen_headers        = 'Yes'
            absolute_column_width = '5,8,8,10,13,13') ;

proc print data=WGT noobs label ; run ;

ods tagsets.excelxp close ;
ods listing ;

*--- ODS HTML ;
*--- Example 1 ;
ods listing close ;
ods html path  = "C:\temp"
         body  = "_BODY.htm"
         style = statistical ;

title "̏dωʂ̗v񓝌v" ;
proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
          WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;
title ;

ods html close ;
ods listing ;

*--- Example 2 ;
ods listing close ;
ods html path  = "C:\temp"    body = "_BODY.htm" contents = "_CONTENTS.htm"
         frame = "_FRAME.htm" page = "_PAGE.htm" newfile  = proc
         style = festival ;

ods proclabel="Rec1" ;
title "̏dωʂ̗v񓝌v" ;

proc tabulate data=WGT contents="̏dωʂ̗v񓝌v" ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
 WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
 MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) / contents="\1" ;
run ;

ods proclabel="Rec2" ;
title "͕ωʂ̗v񓝌v" ;

proc tabulate data=WGT contents="͕ωʂ̗v񓝌v" ;
   class  TREAT VISIT ;
   var    ABD_CHG ;
   table  VISIT=''*TREAT='',
          ABD_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) / contents="\2" ;
run ;

title ;
ods html close ;
ods listing ;

*--- ODS PDF ;
ods listing close ;
ods pdf file="C:\temp\output.pdf" pdftoc=3 style=minimal ;

ods proclabel="Rec1" ;
title "̏dωʂ̗v񓝌v" ;

proc tabulate data=WGT contents="̏dωʂ̗v񓝌v" ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
 WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
 MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) / contents="\1" ;
run ;

ods proclabel="Rec2" ;
title "͕ωʂ̗v񓝌v" ;

proc tabulate data=WGT contents="͕ωʂ̗v񓝌v" ;
   class  TREAT VISIT ;
   var    ABD_CHG ;
   table  VISIT=''*TREAT='',
          ABD_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) / contents="\2" ;
run ;

title ;
ods pdf close ;
ods listing ;

*--- ODS Layout ;
*--- Example 1 ;
ods listing close ;

title "ODS Layout: columns=2 rows=2" ;
options orientation=landscape nocenter papersize=A4 ;

ods pdf file="C:\temp\output.pdf" style=analysis ;
ods layout start columns=2 rows=2 ;

ods region width=5in ;
proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
          WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;
title ;

ods region width=5in ;
ods graphics on / width=4in height=3in ;
proc sgplot data=WGT ;
   vline VISIT / response=WGT_CHG group=TREAT stat=mean limitstat=stddev 
                 limits=both markers markerattrs=(symbol=circlefilled) ;
   xaxis offsetmin=0.1 offsetmax=0.1 ;
run ;

ods region width=5in ;
proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    ABD_CHG ;
   table  VISIT=''*TREAT='',ABD_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                                     MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;

ods region width=5in ;
ods graphics on / width=4in height=3in ;
proc sgplot data=WGT ;
   vline VISIT / response=ABD_CHG group=TREAT stat=mean limitstat=stddev 
                 limits=both markers markerattrs=(symbol=circlefilled) ;
   xaxis offsetmin=0.1 offsetmax=0.1 ;
run ;

ods layout end ;
ods pdf close ;
ods listing ;
title ;

*--- Example 2 ;
ods listing close ;

title "ODS Layout: columns=2 rows=3, column_span=2" ;
options orientation=portrait papersize=A4 ;
ods pdf file="C:\temp\output.pdf" style=analysis ;
ods layout start columns=2 rows=3 ;

ods region width=3.5in height=3.5in ;
proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='',
          WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                   MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;
title ;

ods region width=3.5in height=3.5in ;
ods graphics on / width=3in height=3in ;
proc sgplot data=WGT ;
   vline VISIT / response=WGT_CHG group=TREAT stat=mean limitstat=stddev 
                 limits=both markers markerattrs=(symbol=circlefilled) ;
   xaxis offsetmin=0.1 offsetmax=0.1 ;
run ;

ods region width=3.5in height=3.5in ;
proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    ABD_CHG ;
   table  VISIT=''*TREAT='',ABD_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3
                                     MIN*f=8.1 MEDIAN*f=8.2 MAX*f=8.1) ;
run ;

ods region width=3.5in height=3.5in ;
ods graphics on / width=3in height=3in ;
proc sgplot data=WGT ;
   vline VISIT / response=ABD_CHG group=TREAT stat=mean limitstat=stddev 
                 limits=both markers markerattrs=(symbol=circlefilled) ;
   xaxis offsetmin=0.1 offsetmax=0.1 ;
run ;

ods region column_span=2 ;
proc tabulate data=WGT ;
  class  VISIT TREAT GENDER ;
  var    WGT_CHG ABD_CHG ;
  table  VISIT=''*TREAT=''*GENDER='',
         (WGT_CHG ABD_CHG)*(N*f=8.0 MEAN*f=8.2 STD*f=8.3 MIN*f=8.1 MAX*f=8.1)
         / box='_/܌Q/' ;
  label    TREAT='܌Q: ' GENDER='';
  keylabel N='ᐔ' MEAN='ϒl' STD='W΍' MIN='ŏ' MAX='ő' ;
run ;

ods layout end ;
ods pdf close ;
ods listing ;

*--- style attribute ;
*--- rules ;
ods rtf file="C:\temp\output.rtf" style=theme startpage=no ;

proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={rules=all} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={rules=cols} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={rules=group} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={rules=rows} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={rules=none} ;
run ;

ods rtf close ;

*--- frame ;
ods rtf file="C:\temp\output.rtf" style=theme startpage=no ;

proc tabulate data=WGT ;
   class  TREAT VISIT ;
   var    WGT_CHG ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={frame=box rules=none} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={frame=hsides rules=none} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={frame=void rules=none} ;
   table  VISIT=''*TREAT='', WGT_CHG*(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
          / style={frame=vsides rules=none} ;
run ;

ods rtf close ;

*--- rules and frame in detail ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

proc report data=WGT
   style(report)={frame=void rules=group}
   style(header)={bordertopstyle=solid   bordertopwidth=1}
   style(column)={bordertopstyle=dashed  bordertopwidth=1}
   nowd split="*" ;

   column VISIT TREAT WGT_CHG,(n mean std) ;
   define VISIT   / group "Visit" ;
   define TREAT   / group "Treatment*A/B" ;
   define WGT_CHG / analysis " " format=8.2 ;

   break after VISIT
   / summarize suppress
     style={bordertopstyle    = solid bordertopwidth    = 1
            borderbottomstyle = solid borderbottomwidth = 1} ;
quit ;

ods rtf close ;
ods listing ;

*--- rules and frame in detail 2 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

proc report data=WGT
   style(report)={frame=hsides rules=group}
   style(header)={bordertopstyle=solid bordertopwidth=1}
   nowd split="*" ;

   column VISIT TREAT WGT_CHG=A WGT_CHG=B WGT_CHG=C ;
   define VISIT / group "Visit" ;
   define TREAT / group "Treatment*A/B" ;
   define A / analysis n    "N"    format=8.0 ;
   define B / analysis mean "Mean" format=8.1 ;
   define C / analysis std  "SD"   format=8.2 ;

   compute after VISIT
      / style={borderbottomstyle=solid borderbottomwidth=1 height=1};
      line "" ;
   endcomp ;
quit ;

ods rtf close ;
ods listing ;

*--- rules and frame in detail 3 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

proc report data=WGT
  style(report)={frame=void rules=none}
  style(header)={bordertopstyle    = solid bordertopwidth    = 1
                  borderbottomstyle = solid borderbottomwidth = 1}
  nowd split="*" ;

  column VISIT TREAT WGT_CHG,(n mean std) DEF ;
  define VISIT   / group "Visit" ;
  define TREAT   / group "Treatment*A/B" ;
  define WGT_CHG / analysis " " format=8.2 ;
  define DEF / computed noprint ;

  compute DEF ;
   if TREAT = 1 then do ;
    call define('_C2_','style','style={borderbottomstyle=solid borderbottomwidth=1}') ;
    call define('_C3_','style','style={borderbottomstyle=solid borderbottomwidth=1}') ;
    call define('_C4_','style','style={borderbottomstyle=solid borderbottomwidth=1}') ;
    call define('_C5_','style','style={borderbottomstyle=solid borderbottomwidth=1}') ;
   end ;
   if VISIT = . then do ;
    call define(_ROW_,'style','style={borderbottomstyle=solid borderbottomwidth=1}') ;
   end ;
  endcomp ;
  compute VISIT ;
   call define(_COL_,'style','style={background=lightgray}') ;
  endcomp ;      
quit ;

ods rtf close ;
ods listing ;

*--- spanrows, cellpadding ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

proc report data=WGT spanrows
  style(report)={frame=below rules=rows cellpadding=0}
  style(header)={bordertopstyle    = solid bordertopwidth    = 1
                 borderbottomstyle = solid borderbottomwidth = 1}
  nowd split="*" ;

  column VISIT TREAT WGT_CHG,(n mean std) ;
  define VISIT   / group "Visit" style(column)={vjust=c} ;
  define TREAT   / group "Treatment*A/B" ;
  define WGT_CHG / analysis " " format=8.2 ;
quit ;

ods rtf close ;
ods listing ;

*--- font, color, just ;
ods rtf file="C:\temp\output.rtf" style=theme ;

proc tabulate data=WGT ;
   class TREAT VISIT / style={fontfamily = "Courier New"
                              fontsize   = 9pt
                              background = magenda
                              just       = C} ;

   var   WGT_CHG / style={fontfamily = "Courier New"
                          fontsize   = 9pt
                          background = red
                          just       = R} ;

   table VISIT=''*TREAT='',
         WGT_CHG="Summary Statistics"
         *(N*f=8.0 MEAN*f=8.2 STDDEV*f=8.3)
         *{style={fontfamily="Courier New" background=yellow just=C width=80pt}}
    / style={rules=all}
      box={label = "Visit/Treatment"
           style = {fontfamily="Courier New" fontsize=9pt background=pink}} ;

   keyword all n mean stddev / style = {fontfamily = "Courier New"
                                        fontsize   = 9pt
                                        background = blue} ;
run ;

ods rtf close ;

*--- dynamic color with a format ;
proc format ;
   value COLORF LOW - -2   = "lightgray"
                -2< - HIGH = "white" ;
run ;

ods rtf file="C:\temp\output.rtf" style=theme ;
proc tabulate data=WGT;
   class TREAT VISIT ;
   var   WGT_CHG ;
   table VISIT=''*TREAT='',
         WGT_CHG*mean*f=8.2*{style={background=COLORF.}} ;
run ;
ods rtf close ;

*--- 4.6 templatevVW ;
*--- Example 1 ;
proc template ;
 define table XXX ;
  style={rules=groups frame=below} ;

  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT          ; header="_"     ; style={width=50pt just=r} format=VISITF. ; end ;
   define TREAT          ; header="^Q"   ; style={width=50pt just=r} format=TRTF.   ; end ;
   define WGT_CHG_N      ; header="ᐔ"     ; style={width=40pt just=r} format=6.0     ; end ;
   define WGT_CHG_Mean   ; header="ϒl"   ; style={width=40pt just=r} format=6.2     ; end ;
   define WGT_CHG_StdDev ; header="W΍" ; style={width=40pt just=r} format=6.3     ; end ;
   define WGT_CHG_Min    ; header="ŏl"   ; style={width=40pt just=r} format=6.1     ; end ;
   define WGT_CHG_Max    ; header="ől"   ; style={width=40pt just=r} format=6.1     ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- Example 2.1 ;
proc template ;
 define table XXX ;
  style={rules=rows frame=hsides} ;

  header H1 H2 ;
   define H1 ; text ""           ; just=c ; start=VISIT     ; end=TREAT       ; end ;
   define H2 ; text "v񓝌v" ; just=c ; start=WGT_CHG_N ; end=WGT_CHG_MAX ; end ;
  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT          ; header="_"     ; style={width=50pt just=r} format=VISITF. ; end ;
   define TREAT          ; header="^Q"   ; style={width=50pt just=r} format=TRTF.   ; end ;
   define WGT_CHG_N      ; header="ᐔ"     ; style={width=50pt just=r} format=4.0     ; end ;
   define WGT_CHG_Mean   ; header="ϒl"   ; style={width=50pt just=r} format=4.1     ; end ;
   define WGT_CHG_StdDev ; header="W΍" ; style={width=50pt just=r} format=4.2     ; end ;
   define WGT_CHG_Min    ; header="ŏl"   ; style={width=50pt just=r} format=4.0     ; end ;
   define WGT_CHG_Max    ; header="ől"   ; style={width=50pt just=r} format=4.0     ; end ;
  footer F1 F2 ;
   define F1 ; text "tbgm[g1: ̏dωʂ̗v񓝌v" ; just=l ; end ;
   define F2 ; text "tbgm[g2: ev[gXXXgp" ; just=l ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- Example 2.2 ;
proc template ;
 define table XXX ;
  style={rules=rows frame=hsides} ;

  header H1 H2 ;
   define H1 ; text ""           ; just=c ; start=TREAT     ; end=TREAT       ; end ;
   define H2 ; text "v񓝌v" ; just=c ; start=WGT_CHG_N ; end=WGT_CHG_MAX ; end ;
  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT          ; header="_"     ; style={width=50pt just=r} format=VISITF. ; end ;
   define TREAT          ; header="^Q"   ; style={width=50pt just=r} format=TRTF.   ; end ;
   define WGT_CHG_N      ; header="ᐔ"     ; style={width=50pt just=r} format=4.0     ; end ;
   define WGT_CHG_Mean   ; header="ϒl"   ; style={width=50pt just=r} format=4.1     ; end ;
   define WGT_CHG_StdDev ; header="W΍" ; style={width=50pt just=r} format=4.2     ; end ;
   define WGT_CHG_Min    ; header="ŏl"   ; style={width=50pt just=r} format=4.0     ; end ;
   define WGT_CHG_Max    ; header="ől"   ; style={width=50pt just=r} format=4.0     ; end ;
  footer F1 F2 ;
   define F1 ; text "tbgm[g1: ̏dωʂ̗v񓝌v" ; style={just=l borderbottomstyle=none} ; end ;
   define F2 ; text "tbgm[g2: ev[gXXXgp"    ; style={just=l borderbottomstyle=none} ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- Example 3 ;
proc template ;
 define table XXX ;
  style={rules=rows frame=hsides} ;

  header H11 H12 H21 H22 H23 H24 H25 H26 H27 ;
   define H11 ; text ""           ; just=c ; start=VISIT          ; end=TREAT          ; end ;
   define H12 ; text "v񓝌v" ; just=c ; start=WGT_CHG_N      ; end=WGT_CHG_MAX    ; end ;
   define H21 ; text "_"       ; just=c ; start=VISIT          ; end=VISIT          ; end ;
   define H22 ; text "^Q"     ; just=c ; start=TREAT          ; end=TREAT          ; end ;
   define H23 ; text "ᐔ"       ; just=c ; start=WGT_CHG_N      ; end=WGT_CHG_N      ; end ;
   define H24 ; text "ϒl"     ; just=c ; start=WGT_CHG_Mean   ; end=WGT_CHG_Mean   ; end ;
   define H25 ; text "W΍"   ; just=c ; start=WGT_CHG_StdDev ; end=WGT_CHG_StdDev ; end ;
   define H26 ; text "ŏl"     ; just=c ; start=WGT_CHG_Min    ; end=WGT_CHG_Min    ; end ;
   define H27 ; text "ől"     ; just=c ; start=WGT_CHG_Max    ; end=WGT_CHG_Max    ; end ;
  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT          ; print_headers=off ; style={width=50pt just=c} format=VISITF. ; end ;
   define TREAT          ; print_headers=off ; style={width=50pt just=c} format=TRTF.   ; end ;
   define WGT_CHG_N      ; print_headers=off ; style={width=50pt just=c} format=4.0     ; end ;
   define WGT_CHG_Mean   ; print_headers=off ; style={width=50pt just=c} format=4.1     ; end ;
   define WGT_CHG_StdDev ; print_headers=off ; style={width=50pt just=c} format=4.2     ; end ;
   define WGT_CHG_Min    ; print_headers=off ; style={width=50pt just=c} format=4.0     ; end ;
   define WGT_CHG_Max    ; print_headers=off ; style={width=50pt just=c} format=4.0     ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- Example 4 ;
proc template ;
 define table XXX ;
  style={rules=rows frame=hsides} ;

  header H11 H12 H21 H22 H23 H24 H25 H26 H27 ;
   define H11 ; text ""           ; just=c ; start=VISIT          ; end=TREAT          ; end ;
   define H12 ; text "v񓝌v" ; just=c ; start=WGT_CHG_N      ; end=WGT_CHG_MAX    ; end ;
   define H21 ; text "_"       ; just=c ; start=VISIT          ; end=VISIT          ; end ;
   define H22 ; text "^Q"     ; just=c ; start=TREAT          ; end=TREAT          ; end ;
   define H23 ; text "ᐔ"       ; just=c ; start=WGT_CHG_N      ; end=WGT_CHG_N      ; end ;
   define H24 ; text "ϒl"     ; just=c ; start=WGT_CHG_Mean   ; end=WGT_CHG_Mean   ; end ;
   define H25 ; text "W΍"   ; just=c ; start=WGT_CHG_StdDev ; end=WGT_CHG_StdDev ; end ;
   define H26 ; text "ŏl"     ; just=c ; start=WGT_CHG_Min    ; end=WGT_CHG_Min    ; end ;
   define H27 ; text "ől"     ; just=c ; start=WGT_CHG_Max    ; end=WGT_CHG_Max    ; end ;
  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT          ; blank_dups=on ; print_headers=off ; style={cellwidth=50pt just=c} format=VISITF. ; end ;
   define TREAT          ; print_headers=off ; style={width=50pt just=c} format=TRTF. ; end ;
   define WGT_CHG_N      ; print_headers=off ; style={width=50pt just=c} format=4.0   ; end ;
   define WGT_CHG_Mean   ; print_headers=off ; style={width=50pt just=c} format=4.1   ; end ;
   define WGT_CHG_StdDev ; print_headers=off ; style={width=50pt just=c} format=4.2   ; end ;
   define WGT_CHG_Min    ; print_headers=off ; style={width=50pt just=c} format=4.0   ; end ;
   define WGT_CHG_Max    ; print_headers=off ; style={width=50pt just=c} format=4.0   ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- Example 5 ;
proc template ;
 define table XXX ;
  style={rules=rows frame=hsides} ;

  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT ;
      header="_" ;
      blank_dups=on ;
      style={width=50pt just=r} format=VISITF. ;
      cellstyle TREAT = 1 as {borderbottomstyle=none} ;
   end ;
   define TREAT          ; header="^Q"   ; style={width=50pt just=r} format=TRTF. ; end ;
   define WGT_CHG_N      ; header="ᐔ"     ; style={width=40pt just=r} format=6.0   ; end ;
   define WGT_CHG_Mean   ; header="ϒl"   ; style={width=40pt just=r} format=6.2   ; end ;
   define WGT_CHG_StdDev ; header="W΍" ; style={width=40pt just=r} format=6.3   ; end ;
   define WGT_CHG_Min    ; header="ŏl"   ; style={width=40pt just=r} format=6.1   ; end ;
   define WGT_CHG_Max    ; header="ől"   ; style={width=40pt just=r} format=6.1   ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- Example 6 ;
proc template ;
 define table XXX ;
  style={rules=rows frame=hsides} ;

  cellstyle mod(_COL_,2) =  0 as {background=lightgray},
            mod(_COL_,2) ne 0 as {background=darkgray foreground=white} ;

  column VISIT TREAT WGT_CHG_N WGT_CHG_Mean WGT_CHG_StdDev WGT_CHG_Min WGT_CHG_Max ;
   define VISIT ; header="_" ; blank_dups=on ; style={width=50pt just=r} format=VISITF. ;
      cellstyle TREAT = 1 as {borderbottomstyle=none} ;
   end ;
   define TREAT          ; header="^Q"   ; style={width=50pt just=r} format=TRTF. ; end ;
   define WGT_CHG_N      ; header="ᐔ"     ; style={width=40pt just=r} format=6.0   ; end ;
   define WGT_CHG_Mean   ; header="ϒl"   ; style={width=40pt just=r} format=6.2   ; end ;
   define WGT_CHG_StdDev ; header="W΍" ; style={width=40pt just=r} format=6.3   ; end ;
   define WGT_CHG_Min    ; header="ŏl"   ; style={width=40pt just=r} format=6.1   ; end ;
   define WGT_CHG_Max    ; header="ől"   ; style={width=40pt just=r} format=6.1   ; end ;
 end ;
run ;

options orientation=portrait papersize=A4 ;
ods listing close ;
ods rtf file="C:\temp\output.rtf" style=minimal ;

data _null_ ;
  set WGTSUM ;
  file print ods=(template='XXX') ;
  put _ods_ ;
run ;

ods rtf close ;
ods listing ;

*--- 4.7 Gȃ|[g̍쐬 ;
*--- f[^쐬 ;
data DEMOG ;
   input ID TREAT AGE GENDER HEIGHT WEIGHT SMOKE @@ ;
cards;
1  1  86 2  187.2 67.6  2 21 2  64 1  170.7 63.5  2
2  2  52 1  157.6 55.4  2 22 1  40 1  166.4 42.4  2
3  2  59 1  159.0 45.5  1 23 1  58 1  165.3 75.2  2
4  1  50 2  176.6 64.2  2 24 2  48 2  158.6 63.4  2
5  1  71 2  177.1 55.0  1 25 1  45 1  156.7 52.9  2
6  2  52 1  148.4 44.4  1 26 1  42 1  144.6 52.6  2
7  1  52 2  171.8 51.2  1 27 1  61 2  177.3 65.1  2
8  1  48 2  162.7 68.9  1 28 1  58 1  163.6 62.7  1
9  1  66 1  160.5 74.4  2 29 2  63 1  170.2 65.6  1
10 2  69 2  174.3 50.8  2 30 1  71 2  190.2 75.5  2
11 1  58 1  149.9 61.9  1 31 2  48 2  169.7 81.1  1
12 2  38 2  163.5 66.9  2 32 2  49 2  177.8 74.9  1
13 1  51 2  153.1 51.9  1 33 1  72 1  165.4 50.5  2
14 2  49 2  175.9 56.8  2 34 2  53 1  163.7 59.9  1
15 1  37 2  170.4 41.8  2 35 2  46 1  153.8 54.7  1
16 1  51 1  165.2 68.9  1 36 1  51 1  158.3 55.7  1
17 2  34 2  188.0 52.7  2 37 2  57 1  156.9 70.3  1
18 2  55 1  173.0 48.1  2 38 2  57 1  162.4 59.5  2
19 1  57 2  180.9 54.3  2 39 2  55 1  141.8 77.8  2
20 1  40 2  162.2 67.5  1 40 2  45 1  171.9 51.6  2
;
run ;

*--- (1) Aϐ ;
*--- 1. e܌Q̗v񓝌vʂ̎Zo ;
proc summary data=DEMOG nway ;
   var AGE ;
   class TREAT  ;
   output out=_AGE(drop=_FREQ_ _TYPE_) n=_N mean=_MEAN stddev=_SD ;
run ;
*--- 2. vʂ̃xw ;
data _AGE ;
   set _AGE ;
   label _N="N" _MEAN="Mean" _SD="SD" ;
run ;
*--- 3. f[^Zbg̓]u(܌QɓWJ) ;
proc transpose data=_AGE out=_AGE_T prefix=_GRP ;
   var _N _MEAN _SD ;
   id TREAT ;
run ;
*--- 4. vʂ̒letH[}bgŕɕϊ ;
data RES_AGE ;
   length LABEL _LABEL_ _RES1 _RES2 $20. ;
   set _AGE_T ;

   LABEL = "Age(years)" ;

   if _NAME_ = "_N"    then do ; *--- ᐔ𕶎ϊ ;
      _RES1 = put(_GRP1,best.) ;
      _RES2 = put(_GRP2,best.) ;
   end ;
   if _NAME_ = "_MEAN" then do ; *--- ϒl𕶎ϊ ;
      _RES1 = put(_GRP1,8.1) ;
      _RES2 = put(_GRP2,8.1) ;
   end ;
   if _NAME_ = "_SD"   then do ; *--- W΍𕶎ϊ ;
      _RES1 = put(_GRP1,8.2) ;
      _RES2 = put(_GRP2,8.2) ;
   end ;
   keep LABEL _LABEL_ _RES1 _RES2 ;
run ;

*--- (2) JeSϐ ;
*--- 1. e܌Q̃JeSƂ̗ᐔƃp[ZgZo ;
ods listing close ;
proc tabulate data=DEMOG out=_GENDER ;
   class TREAT GENDER ;
   var WEIGHT ;
   table TREAT,GENDER*(n rowpctn)  ;
run ;
ods listing ;
*--- 2. ᐔƃp[Zg𕶎ϊėᐔ(%)Ɍ ;
data _GENDER ;
   set _GENDER ;
   _RES=put(N,best.)||"("||right(put(pctn_10,6.1))||")" ;
run ;
*--- 3. f[^Zbg̓]u(܌QɓWJ) ;
proc sort data=_GENDER ; by GENDER ; run ;
proc transpose data=_GENDER out=_GENDER_t prefix=_RES ;
   by GENDER ;
   var _RES ;
   id TREAT ;
run ;
*--- 4. JeSϐ̃tH[}bg쐬 ;
proc format ;
   value GENDERF 1="Male" 2="Female" ;
run ;
*--- 5. JeS̒lɃtH[}bg蓖Ăĕϊ ;
data RES_GENDER ;
   length LABEL _LABEL_ $20. ;
   LABEL="Gender" ;
   set _GENDER_t ;
   _LABEL_ = left(put(GENDER,GENDERF.)) ;
   keep LABEL _LABEL_ _RES1 _RES2 ; 
run ;

*--- (3) |[g̍쐬 ;
*--- 1. AϐƃJeSϐ̌ʂc ;
data RESULT ;
   set RES_AGE RES_GENDER ;
run ;

*--- 2. |[g̏o(styleXe[ggőJX^}CY) ;
ods listing close ;
ods rtf file="C:\temp\report.rtf"
    style=minimal ;
proc report data=RESULT nowd split="#"
 style(report)={frame=hsides rules=none background=white cellpadding=0pt}
 style(header)={fontfamily="MS Gothic"   fontsize=10pt height=15pt
                just=c vjust=bottom}
 style(column)={fontfamily="Courier New" fontsize=10pt height=15pt
                    vjust=c} ;
 column LABEL _LABEL_ _RES1 _RES2 DEF ;
 define LABEL   / order "" style={width=80pt} ;
 define _LABEL_ / display "v/JeS" style={width=80pt} ;
 define _RES1   / display "1" style(column)={just=r width=80pt} ;
 define _RES2   / display "2" style(column)={just=r width=80pt} ;
 define DEF     / computed noprint ;

 compute DEF ; *--- ڂƂ̉r̐ ;
  if LABEL ne "" then do ;
   call define(_ROW_,'style','style={bordertopstyle=solid bordertopwidth=1}') ;
  end ;
 endcomp ;
run ;

ods rtf close ;
ods listing ;

*--- v񓝌vʂƌ茋ʂ̏o ;
*--- v񓝌vʂ̎Zo ;
proc summary data=DEMOG nway ;
   class TREAT ;
   var WEIGHT ;
   output out=_OUT(drop=_TYPE_ _FREQ_) n=N mean=MEAN stddev=SD ;
run ;
*--- 2W{t̎s ;
ods listing close ;
ods output Ttests=_TTEST(where=(method="Pooled")) ;
proc ttest data=DEMOG ;
   class TREAT ;
   var WEIGHT ;
run ;
ods output close ;
ods listing ;
*--- vZʂi[f[^Zbǧ ;
data _OUT ; merge _OUT _TTEST ; run ;
*--- ͑Ώەϐ̃x̊i[ ;
data _OUT ;
   length LABEL $20. ;
   set _OUT ;
   LABEL = "Weight(kg)" ;
run ;
*--- l̋󔒏o ;
options missing=" " ;
*--- ܌Qϐ̃tH[}bg쐬 ;
proc format ;
   value TRTRF 1 = "1" 2 = "2" ;
run ;
*--- |[g̍쐬 ;
ods listing close ;
ods rtf file="%sysfunc(pathname(work))\report.rtf" style=minimal ;
proc report data=_OUT nowd
   style(report)={frame=hsides rules=rows}
   style(header)={background=white fontfamily="Courier New"}
   style(column)={background=white fontfamily="Courier New"} ;
   column LABEL TREAT N MEAN SD tValue Probt _LINE ;
   define LABEL  / order ;
   define TREAT  / display format=TRTRF. ;
   define N      / display format=best. ;
   define MEAN   / display format=8.1 ;
   define SD     / display format=8.2 ;
   define _LINE  / computed noprint ;
   define tValue / display "t-value" format=8.3 ;
   define Probt  / display "p-value" format=8.3 ;
   compute _LINE ; *--- 1sڂ2sڂ̊Ԃ̌ro͂̐ ;
      if LABEL ne "" then do ;
         call define('_C1_','style','style={borderbottomstyle=none}') ;
         call define('_C6_','style','style={borderbottomstyle=none}') ;
         call define('_C7_','style','style={borderbottomstyle=none}') ;
      end ;
   endcomp ;
run ;
ods rtf close ;
ods listing ;




